Package: dosedesignR
Type: Package
Title: Interactive Designing of Dose Finding Studies
Version: 0.3.0
Author: F. Mendolia, K. Walkamp, K. Roth, T. Schmelter, C. Neumann,  Z. Gao, A. Kaiser, S. Jeske, H. Kulmann
Maintainer: T. Schmelter <thomas.schmelter@bayer.com>
Description: Provides the user with an interactive application which can be used to facilitate the planning of dose finding studies by applying the theory of optimal experimental design. 
Depends: R (>= 3.6.0)
License: GPL-3
Encoding: UTF-8
Imports: utils, shiny, DT, latticeExtra, ggplot2, shinyjs, purrr,
        stringr, shinyWidgets, DoseFinding, shinyBS, readxl, knitr,
        kableExtra, Rsolnp
VignetteBuilder: knitr
NeedsCompilation: no
RoxygenNote: 7.2.3
Packaged: 2023-02-20 12:07:34 UTC; SGRPP
Repository: CRAN
Date/Publication: 2023-02-20 13:00:07 UTC
Built: R 4.6.0; ; 2026-04-25 12:55:12 UTC; unix

Package: dosedesignR
Type: Package
Title: Interactive Designing of Dose Finding Studies
Version: 0.3.0
Author: F. Mendolia, K. Walkamp, K. Roth, T. Schmelter, C. Neumann,  Z. Gao, A. Kaiser, S. Jeske, H. Kulmann
Maintainer: T. Schmelter <thomas.schmelter@bayer.com>
Description: Provides the user with an interactive application which can be used to facilitate the planning of dose finding studies by applying the theory of optimal experimental design. 
Depends: R (>= 3.6.0)
License: GPL-3
Encoding: UTF-8
Imports: utils, shiny, DT, latticeExtra, ggplot2, shinyjs, purrr,
        stringr, shinyWidgets, DoseFinding, shinyBS, readxl, knitr,
        kableExtra, Rsolnp
VignetteBuilder: knitr
NeedsCompilation: no
RoxygenNote: 7.2.3
Packaged: 2023-02-20 12:07:34 UTC; SGRPP
Repository: CRAN
Date/Publication: 2023-02-20 13:00:07 UTC
Built: R 4.2.0; ; 2023-07-11 01:16:20 UTC; unix

#' doseLevel module ui function
#'
#' @description A shiny Module for the doseLevels in dosedesignR.
#'
#' @param id Internal parameters for {shiny}.
#'
#' @noRd
#'
#' @importFrom shiny NS tagList

doseLevelUI <- function(id){
  dosedesignR_green <- "#5cb85c"
  dosedesignR_blue <- "#3a6791"
  dosedesignR_red <- "#c94053"
  ns <- shiny::NS(id)

  shiny::fluidPage(
    shiny::fluidRow(
      shinyjs::useShinyjs(),
      shiny::uiOutput(ns("doseUI")),     #group 1-4
      shiny::uiOutput(ns("doseUI2")),    #group 5-8
      shiny::uiOutput(ns("doseUI3")),    #group 9-12
      shiny::uiOutput(ns("doseUI4")),    #group 13-16
      shiny::uiOutput(ns("doseUI5")),    #group 17-20
      shiny::actionButton(
        inputId = ns("add"),
        label = "Add 4 groups",
        icon = icon("plus-circle"),
        style = paste0("color: #fff; background-color: ", dosedesignR_blue, "; border-color: #2e6da4")
      ),
      shiny::actionButton(
        inputId = ns("remove"),
        label = "Reduce 4 groups",
        icon = icon("minus-circle"),
        style = paste0("color: #fff; background-color: ", dosedesignR_blue, "; border-color: #2e6da4")
      )
    )
  )
}


#' doseLevel module server function
#'
#' @param input,output,session Internal parameters for {shiny}.
#' @noRd

doseLevel <- function(input, output, session) {
  #hide all textinput for the level/dose 5-20
  shinyjs::hide("doseUI2")
  shinyjs::hide("doseUI3")
  shinyjs::hide("doseUI4")
  shinyjs::hide("doseUI5")
  #create reactive value to determine the number of 'add'/'remove' button
  #clicks. Start value is 1 which means only 4 Textinputs are shown.
  #Maximum value (restricted through observeEvent handler) is 5 which means
  #that all 20 Textinputs are shown.
  showhide <- shiny::reactiveValues(val = 1)

  shiny::observeEvent(input$add, {
    if (showhide$val < 5){
      showhide$val <- showhide$val + 1
    }
  })

  shiny::observeEvent(input$remove, {
    if (showhide$val > 1) {
      showhide$val <- showhide$val - 1
    }
  })

  shiny::observeEvent(showhide$val, {
    if (showhide$val == 1) {
      for (i in 2:5) {
        shinyjs::hide(paste0("doseUI", i))
      }
    } else if (showhide$val == 2) {
      for (i in 3:5) {
        shinyjs::hide(paste0("doseUI", i))
      }
      shinyjs::show("doseUI2")
    } else if (showhide$val == 3) {
      for (i in 4:5) {
        shinyjs::hide(paste0("doseUI", i))
      }
      for (i in 2:3) {
        shinyjs::show(paste0("doseUI", i))
      }
    } else if (showhide$val == 4) {
      shinyjs::hide("doseUI5")
      for (i in 2:4) {
        shinyjs::show(paste0("doseUI", i))
      }
    } else if (showhide$val == 5) {
      for (i in 2:5) {
        shinyjs::show(paste0("doseUI", i))
      }
    }
  })

  # call module doseLevel_UI from innerdoseLevel_Module.R
  shiny::observe({
    output$doseUI <- shiny::renderUI({
      purrr::map(paste0("tmp", 1:4), ~doseLevel_UI(id = session$ns(.x)))
    })
    output$doseUI2 <- shiny::renderUI({
      purrr::map(paste0("tmp", 5:8), ~doseLevel_UI(id = session$ns(.x)))
    })
    output$doseUI3 <- shiny::renderUI({
      purrr::map(paste0("tmp", 9:12), ~doseLevel_UI(id = session$ns(.x)))
    })
    output$doseUI4 <- shiny::renderUI({
      purrr::map(paste0("tmp", 13:16), ~doseLevel_UI(id = session$ns(.x)))
    })
    output$doseUI5 <- shiny::renderUI({
      purrr::map(paste0("tmp", 17:20), ~doseLevel_UI(id = session$ns(.x)))
    })
  })

  call_Mod <- shiny::reactive({
    val <- purrr::map(paste0("tmp", 1:20), ~shiny::callModule(doseLevel_server,.x))
    val
  })

  shiny::observe({(call_Mod())})

  values_level <- shiny::reactive({
    shiny::req(call_Mod())
    cM <- call_Mod()
    tmp <- do.call(rbind.data.frame, lapply(cM, function(x) data.frame(do.call(cbind.data.frame, x), check.names = FALSE)))
    if (dim(tmp)[1] > 0) {
      colnames(tmp) <- c("dose", "patients")
    }
    tmp <- as.data.frame(tmp)

    empty_as_na <- function(x) {
      if ("factor" %in% class(x)) {
        x <- as.character(x)
      }
      ifelse(as.character(x) != "", x, NA)
    }

    dose <- as.numeric(empty_as_na(tmp$dose))
    pat <- as.numeric(empty_as_na(tmp$patients))
    tmp <- data.frame(
      'dose' = dose,
      'patients' = pat,
      stringsAsFactors = FALSE
    )

    tmp_nr <- rowSums(!is.na(tmp))
    if (is.na(which(tmp_nr < 2)[1] - 1)) {
      tmp_nr <- length(tmp$dose)
    } else {
      tmp_nr <- which(tmp_nr < 2)[1] - 1
    }
    if (!is.na(tmp_nr) & tmp_nr > 0) {
      tmp[1:tmp_nr, ]
    }
  })

  return(values_level)
}

dosedesignR_green <- "#5cb85c"
dosedesignR_blue <- "#3a6791"
dosedesignR_red <- "#c94053"

f_col <- colorRamp(c(dosedesignR_blue, "gray89", dosedesignR_green))
f_col_report <- colorRamp(c(dosedesignR_blue, "gray42", dosedesignR_green))

#' Calculate dose-response curve for the linear model
#'
#' @param modelparam A named list of model parameters for the linear model:
#'                   list(intercept=, slope=)
#' @param minD The smallest dose level
#' @param maxD The largest dose level
#'
#' @return Returns a 2 x D matrix, where D is the number of dose levels.
#'         The first contains the dose levels, the second row the response
#'         for each dose level.
#' @export
#'
#' @examples FncLinear(list(intercept=3, slope=7), 0, 100)

FncLinear <- function(
  modelparam,
  minD = 0,
  maxD
) {
  intercept <- modelparam$intercept
  slope <- modelparam$slope
  x <- 0:maxD
  y <- intercept + slope * x
  return(rbind(x, y))
}

#' Calculate dose-response curve for the emax model
#'
#' @param modelparam A named list of model parameters for the emax model:
#'                   list(E0=, ED50=, Emax=)
#' @param minD The smallest dose level
#' @param maxD The largest dose level
#'
#' @return Returns a 2 x D matrix, where D is the number of dose levels.
#'         The first contains the dose levels, the second row the response
#'         for each dose level.
#' @export
#'
#' @examples FncEmax(list(E0=3, ED50=20, Emax=100), 0, 100)

FncEmax <- function(
  modelparam,
  minD = 0,
  maxD
){
  E0 <- modelparam$E0
  ED50 <- modelparam$ED50
  Emax <- modelparam$Emax
  x <- 0:maxD
  y <- E0 + Emax * x/(ED50 + x)
  return(rbind(x, y))
}

#' Calculate dose-response curve for the sigmoidal emax model
#'
#' @param modelparam A named list of model parameters for the sigmoidal emax model:
#'                   list(E0=, ED50=, Emax=, Hill=)
#' @param minD The smallest dose level
#' @param maxD The largest dose level
#'
#' @return Returns a 2 x D matrix, where D is the number of dose levels.
#'         The first contains the dose levels, the second row the response
#'         for each dose level.
#' @export
#'
#' @examples FncEmax(list(E0=3, ED50=20, Emax=100), 0, 100)
FncSigEmax <- function(
  modelparam,
  minD = 0,
  maxD
){
  E0 <- modelparam$E0
  ED50 <- modelparam$ED50
  Emax <- modelparam$Emax
  Hill <- modelparam$Hill
  x <- 0:maxD
  y <- E0 + Emax * x^Hill/(ED50^Hill + x^Hill)
  return(rbind(x, y))
}

#' Function to compute the model function
#'
#' @param input
#' @param tab
#' @param ymin
#' @param ymax
#' @param dmin
#' @param dmax
#' @param data
#' @param data_esti
#' @param plot_opt
#' @param selectnr
#'
#'

ComputeModelFunction <- function(
  input,
  tab,
  ymin,
  ymax,
  dmin,
  dmax,
  data = data,
  data_esti,
  plot_opt,
  selectnr
) {

  model <- input$model
  x <- seq(dmin,dmax, length = 201)
  if (model == "Linear") {
    Int <- input$parameter1
    Slp <- input$parameter2

    y <- linear(x, Int, Slp)

    if (!is.null(data_esti) & !is.null(selectnr)) {
      y_tmp <- lapply(data_esti[selectnr], function(x){ fitMod(x$df$dose, x$df$response, model = "linear")$coefs %>% as.numeric()} )
      y2 <- lapply(y_tmp, function(z){linear(x,z[1], z[2])})
    }

  } else if (model == "Emax") {
    E0 <- input$parameter1
    ED50 <- input$parameter2
    Emax <- input$parameter3
    y <- emax(x, e0 = E0, ed50 = ED50, eMax = Emax)
    if (!is.null(data_esti)) {
      y_tmp <- lapply(data_esti[selectnr], function(x){fitMod(x$df$dose, x$df$response, model="emax", bnds = defBnds(max(x$df$dose))$emax)$coefs  %>% as.numeric()})
      y2 <- lapply(y_tmp,function(z){ emax(x,e0=z[1], ed50=z[3], eMax=z[2])})
    }
  } else if(model == "Sigmoidal Emax") {
    E0 <- input$parameter1
    ED50 <- input$parameter2
    Emax <- input$parameter3
    Hill <- input$parameter4

    y <- sigEmax(x, e0 = E0, ed50 = ED50, eMax = Emax, h = Hill)
    if(!is.null(data_esti) & !is.null(selectnr)){
      y_tmp <-lapply(data_esti[selectnr], function(x){ fitMod(x$df$dose,x$df$response, model="sigEmax", bnds=defBnds(max(x$df$dose))$sigEmax)$coefs %>% as.numeric() } )
      y2 <-lapply(y_tmp,function(z){sigEmax(x,e0 = z[1], ed50 = z[3], eMax = z[2], h = z[4])})
    }
  }

  datplot <- data.frame(x,y)

  if (!is.null(selectnr)) {
    data_dummy <- data
    sn <- selectnr
    data_dummy2 <- data_dummy$data[sn]
    data_dummy3 <- do.call(rbind.data.frame,lapply(data_dummy2, function(x) data.frame(do.call(cbind.data.frame,x),check.names = FALSE)))

    for(i in 1:length(y2)) {
     data_cols <- rgb(f_col(seq(0, 1, length = length(data$data))), maxColorValue = 255)
     y2[[i]] <- cbind.data.frame(y2[[i]],'color' = data_cols[selectnr[i]])
     y2[[i]] <- cbind.data.frame(y2[[i]],'nr'= selectnr[i])
     y2[[i]] <- cbind.data.frame(y2[[i]],'x'= datplot$x)
   }
   y3 <- do.call(rbind.data.frame, lapply(y2, function(x) data.frame(do.call(cbind.data.frame, x), check.names = FALSE)))
   colnames(y3) <- c("y","color","nr","x")
  }

  pl <- ggplot(data = datplot, aes(x = x, y = y, group = 1)) +
    ggplot2::theme_minimal() +
    ggplot2::theme(plot.background = ggplot2::element_rect(fill = "#383838")) +
    ggplot2::theme(
      legend.position = "none",
      axis.text = ggplot2::element_text(colour = "white"),
      panel.border = ggplot2::element_blank(),
      panel.grid.major = ggplot2::element_line(colour = "#474747"),
      panel.grid.minor = ggplot2::element_line(colour = "#474747", size = 0.25),
      text = ggplot2::element_text(
        family = "",
        face = "plain",
        colour = "white",
        size = 12,
        lineheight = 0.9,
        hjust = 0.5,
        vjust = 0.5,
        angle = 0,
        margin = margin(),
        debug = FALSE
      )
    ) +
    ggplot2::geom_line(color = dosedesignR_red, lwd = 1.2) +
    ggplot2::labs(x = "Dose", y = "Response", title = "Dose-response curve") +
    ggplot2::ylim(ymin, ymax) +
    {if(!is.null(data_esti) & plot_opt == TRUE & !is.null(selectnr)) geom_line(data = y3, aes(x = y3$x, y = y3$y, group = y3$nr), colour = y3$color, lwd = 1.2)} +
    ggplot2::xlim(dmin, dmax) +
    {if(!is.null(data) & !is.null(selectnr)) geom_point(data = data_dummy3, aes(x = data_dummy3$dose, y = data_dummy3$response),color =data_dummy3$color)} +
    ggplot2::theme(
      axis.text = ggplot2::element_text(size=rel(1.1)),
      axis.title = element_text(size=rel(1.1)),
      plot.title = element_text(
        size = rel(1.25),
        hjust = 0.5,
        face = "bold"
      )
    )
  return(pl)
}


#' Second function to compute the model function (for markdown report)
#'
#' @param model
#' @param tab
#' @param ymin
#' @param ymax
#' @param dmin
#' @param dmax
#' @param data
#' @param data_esti
#' @param plot_opt
#' @param selectnr
#' @param parameter1
#' @param parameter2
#' @param parameter3
#' @param parameter4
#'
ComputeModelFunction2 <- function(
  model,
  tab,
  ymin,
  ymax,
  dmin,
  dmax,
  data_esti,
  data,
  plot_opt,
  selectnr,
  parameter1,
  parameter2,
  parameter3,
  parameter4
) {

  x <- seq(dmin,dmax, length = 201)

  if(model == "Linear") {
    Int <- parameter1
    Slp <- parameter2

    y <- linear(x, Int, Slp)

    if(!is.null(data_esti) & !is.null(selectnr)){

      y_tmp <- lapply(data_esti[selectnr], function(x){ fitMod(x$df$dose, x$df$response, model = "linear")$coefs %>% as.numeric()} )

      y2 <- lapply(y_tmp,function(z){ linear(x,z[1], z[2])})
    }

  } else if(model == "Emax") {
    E0 <- parameter1
    ED50 <- parameter2
    Emax <- parameter3
    y <- emax(x,e0 = E0, ed50 = ED50, eMax = Emax)
    if (!is.null(data_esti)) {

      y_tmp <- lapply(data_esti[selectnr], function(x){ fitMod(x$df$dose, x$df$response, model="emax", bnds = defBnds(max(x$df$dose))$emax)$coefs  %>% as.numeric()})
      y2 <- lapply(y_tmp,function(z){ emax(x,e0=z[1], ed50=z[3], eMax=z[2])})
    }
  } else if(model == "Sigmoidal Emax") {
    E0 <- parameter1
    ED50 <- parameter2
    Emax <- parameter3
    Hill <- parameter4

    y <- sigEmax(x, e0 = E0, ed50 = ED50, eMax = Emax, h = Hill)
    if(!is.null(data_esti) & !is.null(selectnr)){
      y_tmp <-lapply(data_esti[selectnr], function(x){ fitMod(x$df$dose,x$df$response, model="sigEmax", bnds=defBnds(max(x$df$dose))$sigEmax)$coefs %>% as.numeric() } )
      y2 <-lapply(y_tmp,function(z){sigEmax(x,e0 = z[1], ed50 = z[3], eMax = z[2], h = z[4])})
    }
  }

   datplot <- data.frame(x,y)

   if (!is.null(selectnr)) {
     data_dummy <- data
     sn <- selectnr
     data_dummy2 <- data_dummy$data[sn]
     data_dummy3 <- do.call(rbind.data.frame,lapply(data_dummy2, function(x) data.frame(do.call(cbind.data.frame,x),check.names = FALSE)))

      for(i in 1:length(y2)){
        data_cols <- rgb(f_col_report(seq(0, 1, length = length(data$data))), maxColorValue = 255)
        y2[[i]] <- cbind.data.frame(y2[[i]],'color' = data_cols[selectnr[i]])
        y2[[i]] <- cbind.data.frame(y2[[i]],'nr'= selectnr[i])
        y2[[i]] <- cbind.data.frame(y2[[i]],'x'= datplot$x)
      }
      y3 <- do.call(rbind.data.frame, lapply(y2, function(x) data.frame(do.call(cbind.data.frame, x), check.names = FALSE)))
      colnames(y3) <- c("y","color","nr","x")
   }

  pl <- ggplot(data=datplot,aes(x=x,y=y, group = 1) )+
    ggplot2::theme_minimal() +
    ggplot2::theme(plot.background = element_rect(fill = "#f0f0f0")) +
    ggplot2::theme(
      legend.position = "none",
      axis.text = element_text(colour = "black"),
      panel.border = element_blank(),
      panel.grid.major = element_line(colour = "#fafafa"),
      panel.grid.minor = element_line(colour = "#fafafa", size = 0.25),
      text = element_text(
        family = "",
        face = "plain",
        colour = "black",
        size = 12,
        lineheight = 0.9,
        hjust = 0.5,
        vjust = 0.5,
        angle = 0,
        margin = margin(),
        debug = FALSE
      )
    ) +
    geom_line(color = dosedesignR_red, lwd = 1.2) +
    labs(x = "Dose", y = "Response", title = "Dose-response curve") +
    ylim(ymin,ymax) +

    {if(!is.null(data_esti)) geom_line(data = y3, aes(x = y3$x, y = y3$y, group = y3$nr), colour = y3$color, lwd = 1.2)} +

    xlim(dmin, dmax) +

    {if(!is.null(data) & !is.null(selectnr)) geom_point(data = data_dummy3, aes(x = data_dummy3$dose, y = data_dummy3$response),color =data_dummy3$color_report)} +
    theme(axis.text = element_text(size=rel(1.1)),axis.title = element_text(size=rel(1.1)),plot.title = element_text(size=rel(1.25),hjust=0.5,face="bold"))
   return(pl)
}

#' Simulation module ui function
#'
#' @description A shiny Module for the simulation tab in dosedesignR.
#'
#' @param id Internal parameters for {shiny}.
#'
#' @noRd
#'
#' @importFrom shiny NS tagList

dosedesignR_green <- "#5cb85c"
dosedesignR_blue <- "#3a6791"
dosedesignR_red <- "#c94053"
dosedesignR_bright_grey <- "#424242"
dosedesignR_mid_grey <- "#383838"
dosedesignR_dark_grey <- "#333333"

simModule_UI <- function(id) {

  ns <- shiny::NS(id)
  shiny::tagList(
    shiny::tabPanel(
      "Simulation",
      shiny::column(12,
        style = paste0("background-color:#383838;"),
        shiny::uiOutput(ns("sim")),
        shiny::actionButton(ns("gosim"), "Go"),
        shiny::plotOutput(ns("simDesign"))
      )
    )
  )
}

#' Simulation module server function
#'
#' @param input,output,session Internal parameters for {shiny}.
#' @param number number of candidate model
#' @param no tab number
#' @param inp inputs from doseDesign module
#' @param levels level information (from app)
#' @param regimen regimen information (from app)
#' @param npats number of patients (from app)
#' @param dmin dose minimum (from app)
#' @param dmax dose maximum (from app)
#' @param ymin y-axis minimum (from app)
#' @param ymax y-axis maximum (from app)
#' @param sdsim simulation options (from app)
#' @param clevel level information (from app)
#' @noRd


simModule_Server <- function(
  input,
  output,
  session,
  number,
  no,
  inp,
  levels,
  regimen,
  npats,
  dmin,
  dmax,
  ymin,
  ymax,
  sdsim,
  clevel
) {
  output$sim <- shiny::renderUI({
    shiny::selectInput(
      session$ns("sim"),
      NULL,
      c(paste0("Optimal", 1:length(inp())), paste0("User Defined", 1:length(inp()))),
      selected = paste0("Optimal", no)
    )
  })

  output$simDesign <- shiny::renderPlot({
    shiny::validate(need(ymin() < ymax() , 'Maximum response needs to be greater than minimum response.'))
    input$gosim
    # use the function 'performSimulation' from the Simulation.R file
    plotres <- performSimulation(
      input,
      no,
      inp = inp(),
      sdsim = sdsim(),
      dmin = dmin(),
      dmax = dmax(),
      clevel = clevel(),
      sim = inp()$sim,
      model = inp()$model
    )
    if (!is.null(plotres)) {
      suppressWarnings(print(plotres))
    }
  })
}

#' Optimal design for a linear model
#'
#' @param modelparam Not needed, can be set to NA
#' @param regimen Is the maximum dose only given or the actual dose levels?
#' @param minD The smallest dose level
#' @param maxD The largest dose level
#' @param levels A vector of dose levels.
#'
#' @return Returns a 2 x D matrix, where D is the number of dose levels.
#'         The first contains the selected doses, the second row the number of
#'         patients for each dose level.
#' @export
#'
#' @examples OptLinear(NA, "maxOnly", 0, 100, NA)

OptLinear <- function(
  modelparam,
  regimen = c("maxOnly", "levels"),
  minD = 0,
  maxD = NA,
  doselevels = NA
) {
  if (regimen == "maxOnly") {
    doses <- c(minD,maxD)
  } else if(regimen == "levels") {
    doses <- doselevels
  }

  model <- Mods(linear = NULL, doses = doses)
  opt <- optDesign(model, probs = 1)

  idx <- round(opt$design,3) != 0
  res <- rbind(opt$doses[idx], opt$design[idx])

  return(
    list(
      res = res,
      mods = model,
      optD = opt
    )
  )
}

#' Optimal design for an Emax model
#'
#' @param modelparam A named list of model parameters for the emax model:
#'                   list(ED50=)
#' @param regimen Is the maximum dose only given or the actual dose levels?
#' @param minD The smallest dose level
#' @param maxD The largest dose level
#' @param levels A vector of dose levels.
#'
#' @return Returns a 2 x D matrix, where D is the number of dose levels.
#'         The first contains the selected doses, the second row the number of
#'         patients for each dose level.
#' @export
#'
#' @examples OptEmax(list(ED50=20), "levels", 0, NA, c(0,5,40,100))
OptEmax <- function(
  modelparam,
  regimen = c("maxOnly", "levels"),
  minD = 0,
  maxD = NA,
  doselevels = NA
){
  ED50 <- modelparam$ED50

  if (regimen == "maxOnly") {
    doses <- c(minD:maxD, maxD)
    model <- Mods(emax = ED50, doses = doses)
    dopt <- numeric(3)
    dopt[1] <- a <- min(doses)
    dopt[3] <- b <- max(doses)
    dopt[2] <- (b*(a+ED50)+a*(b+ED50))/(a+b+2*ED50)
    design <- c(1/3, 1/3, 1/3)

    cc <- calcCrit(
      design,
      doses = dopt,
      models = model,
      probs = 1
    )
    opt <- NULL
    opt$crit <- cc

    res <- rbind(dopt,design)
  } else if( regimen == "levels") {
    doses <- doselevels
    model <- Mods(emax = ED50, doses = doses)
    opt <- optDesign(model, probs = 1)
    idx <- round(opt$design,3) != 0
    res <- rbind(opt$doses[idx], opt$design[idx])
  }

  return(
    list(
      res = res,
      mods = model,
      optD = opt
    )
  )
}

#' Optimal design for an Sigmoidal Emax model
#'
#' @param modelparam A named list of model parameters for the emax model:
#'                   list(ED50=, Hill=)
#' @param regimen Is the maximum dose only given or the actual dose levels?
#' @param minD The smallest dose level
#' @param maxD The largest dose level
#' @param levels A vector of dose levels.
#'
#' @return Returns a 2 x D matrix, where D is the number of dose levels.
#'         The first contains the selected doses, the second row the number of
#'         patients for each dose level.
#' @export
#'
#' @examples OptEmax(list(ED50=20, Hill=3), "levels", 0, NA, c(0,5,40,100))

OptSigEmax <- function(
  modelparam,
  regimen = c("maxOnly", "levels"),
  minD = 0,
  maxD = NA,
  doselevels = NA
){
  ED50 <- modelparam$ED50
  Hill <- modelparam$Hill

  if(regimen == "maxOnly") {
    doses <- c(minD:maxD, maxD)
    model <- Mods(
      sigEmax = c(ED50, Hill),
      doses = doses
    )
    weights <- rep(0.25, 4) #equal weights on all 4 support points

    dopt <- numeric(4)
    dopt[1] <- min(doses)
    dopt[4] <- max(doses)

    if (ED50 < maxD) {
      a <- (ED50 + minD)/2
      b <- min(c(ED50 + (ED50-a), (ED50+maxD)/2))
    } else {
      a <- (maxD-minD)/3    #initial values for middle support points - set rounding level accordingly
      b <- (maxD-minD)*2/3
    }
    dcrit <- function(x) {
      calcCrit(
        design = weights,
        models = model,
        probs = 1,
        doses = c(minD, x, maxD),
        designCrit = "Dopt"
      )
    }

    optx <- try(optim(c(a,b), dcrit, method="L-BFGS-B", lower=minD, upper=maxD), silent = T)
    if("try-error" %in% class(optx)){
      optx <- try(optim(c(a,b), dcrit, method="L-BFGS-B", lower=minD, upper=maxD, control=list(fnscale=10)), silent = T)
      if("try-error" %in% class(optx)){
        optx <- try(optim(c(a,b), dcrit, method="L-BFGS-B", lower=minD, upper=maxD, control=list(fnscale=0.1)), silent = T)
        if("try-error" %in% class(optx)){
          optx <- try(optim(c(a,b), dcrit, method="L-BFGS-B", lower=minD, upper=maxD, control=list(fnscale=100)), silent = T)
          if("try-error" %in% class(optx)){
            optx <- try(optim(c(a,b), dcrit, method="L-BFGS-B", lower=minD, upper=maxD, control=list(fnscale=0.01)), silent = F)
          }
        }
      }
    }

    dopt[2:3] <- sort(optx$par)
    design <- weights

    cc <- calcCrit(design, doses=dopt, models=model, probs=1)
    opt <- NULL
    opt$crit <- cc

    res <- rbind(dopt,design)
  } else if(regimen == "levels") {
    doses <- doselevels
    model <- Mods(
      sigEmax = c(ED50, Hill),
      doses = doses
    )
    opt <- optDesign(model, probs = 1)

    idx <- round(opt$design,3) != 0
    res <- rbind(opt$doses[idx], opt$design[idx], 3)
  }

  return(
    list(
      res = res,
      mods = model,
      optD = opt
    )
  )
}

ComputeOptimal <- function(
  input,
  regimen,
  levels,
  dmin,
  dmax
){
  if (regimen == "Min and max dose only") {
    regimen_tmp <- "maxOnly"
  } else if (regimen == "Specify dose levels") {
    regimen_tmp <- "levels"
    doselevels <- as.numeric(strsplit(levels, ";")[[1]])
    # ignore Dose levels if fewer than one level
    if (length(doselevels) < 2) {
      regimen_tmp <- "maxOnly"
    }
  }
  model <- input$model
  if (model == "Linear") {
    x <- OptLinear(NA, regimen_tmp, dmin, dmax, doselevels)
  } else if(model == "Emax"){
    ED50 <- input$parameter2

    x <- OptEmax(
      list(ED50 = ED50),
      regimen_tmp,
      dmin,
      dmax,
      doselevels
    )
  } else if(model == "Sigmoidal Emax") {
    ED50 <- input$parameter2
    Hill <- input$parameter4

    x <- OptSigEmax(
      list(ED50 = ED50, Hill = Hill),
      regimen_tmp,
      dmin,
      dmax,
      doselevels
    )

  }

  return(x)
}

#For markdown report.Rmd
ComputeOptimal2 <- function(
  model,
  regimen,
  levels,
  dmin,
  dmax,
  parameter1,
  parameter2,
  parameter3,
  parameter4
){
  if (regimen == "Min and max dose only") {
    regimen_tmp <- "maxOnly"
  } else if (regimen == "Specify dose levels") {
    regimen_tmp <- "levels"
    doselevels <- as.numeric(strsplit(levels, ";")[[1]])
    # ignore Dose levels if fewer than one level
    if (length(doselevels) < 2) {
      regimen_tmp <- "maxOnly"
    }
  }
  if(model == "Linear") {
    x <- OptLinear(NA, regimen_tmp, dmin, dmax, doselevels)
  } else if(model == "Emax"){
    ED50 <- parameter2
    x <- OptEmax(
      list(ED50 = ED50),
      regimen_tmp,
      dmin,
      dmax,
      doselevels
    )
  } else if(model == "Sigmoidal Emax") {
    ED50 <- parameter2
    Hill <- parameter4

    x <- OptSigEmax(
      list(ED50 = ED50, Hill = Hill),
      regimen_tmp,
      dmin,
      dmax,
      doselevels
    )
  }


  return(x)
}

ComputeEfficiency <- function(
  UserValue,
  optValue,
  input,
  tab,
  npats
) {
  doses <- UserValue$doses1
  pats <- UserValue$pats1
  models <- optValue$mods1
  optD <- optValue$optD1
  model <- input$model

  if (length(doses) > 0 & length(doses) == length(pats)) {

    if (model == "Linear" & length(unique(doses)) < 2) {
      dat <- matrix("Need at least 2 different dose levels to calculate Efficiency")
    } else if (model == "Linear" & length(unique(doses)) >= 2) {
      cc <- calcCrit(pats/sum(pats), doses = doses, models = models, probs = 1)
      eff <- (exp(optD$crit)/npats) / (exp(cc)/sum(pats))
      patsAdd <- sum(pats)*1/eff-sum(pats)
      dat <- matrix(c(sum(pats),eff*100,patsAdd), nrow=3, byrow = TRUE)
    }

    if (model == "Emax" & length(unique(doses)) < 3) {
      dat <- matrix("Need at least 3 different dose levels to calculate Efficiency")
    } else if (model == "Emax" & length(unique(doses)) >= 3) {
      cc <- calcCrit(pats/sum(pats), doses=doses, models=models, probs=1)
      eff <- (exp(optD$crit)/npats) / (exp(cc)/sum(pats))
      patsAdd <- sum(pats)*1/eff-sum(pats)
      dat <- matrix(c(sum(pats),eff*100,patsAdd), nrow=3, byrow = TRUE)
    }
    if(model == "Sigmoidal Emax" & length(unique(doses)) < 4) {
        dat <- matrix("Need at least 4 different dose levels to calculate Efficiency")
    } else if (model=="Sigmoidal Emax" & length(unique(doses))>=4) {
      cc <- calcCrit(pats/sum(pats), doses=doses, models=models, probs=1)
      eff <- (exp(optD$crit)/npats) / (exp(cc)/sum(pats))
      patsAdd <- sum(pats)*1/eff-sum(pats)
      dat <- matrix(c(sum(pats),eff*100,patsAdd), nrow=3, byrow=T)
    }
  } else {
    dat <- matrix(NA, nrow = 3, byrow = TRUE)
  }
  return(dat)
}


ComputeEfficiency2 <- function(
  userVal,
  optVal,
  model,
  npats
  ) {
  doses <- userVal$dose
  pats <- userVal$patients
  models <- optVal$mods
  optD <- optVal$optD

  if (length(doses) > 0 & length(doses) == length(pats)) {

    if (model == "Linear" & length(unique(doses)) < 2) {
      dat <- matrix("Need at least 2 different dose levels to calculate Efficiency")
    } else if (model == "Linear" & length(unique(doses)) >= 2) {
      cc <- calcCrit(pats/sum(pats), doses=doses, models=models, probs=1)
      eff <- (exp(optD$crit)/npats) / (exp(cc)/sum(pats))
      patsAdd <- sum(pats)*1/eff-sum(pats)
      dat <- matrix(c(sum(pats),eff*100,patsAdd), nrow=3, byrow=TRUE)
    }

    if (model == "Emax" & length(unique(doses)) < 3){
      dat <- matrix("Need at least 3 different dose levels to calculate Efficiency")
    } else if (model=="Emax" & length(unique(doses)) >=3 ){
      cc <- calcCrit(pats/sum(pats), doses=doses, models=models, probs=1)
      eff <- (exp(optD$crit)/npats) / (exp(cc)/sum(pats))
      patsAdd <- sum(pats)*1/eff-sum(pats)
      dat <- matrix(c(sum(pats),eff*100,patsAdd), nrow=3, byrow=T)
    }
    if(model=="Sigmoidal Emax" & length(unique(doses))<4){
      dat <- matrix("Need at least 4 different dose levels to calculate Efficiency")
    }else if(model == "Sigmoidal Emax" & length(unique(doses)) >= 4){
      cc <- calcCrit(pats/sum(pats), doses=doses, models=models, probs=1)
      eff <- (exp(optD$crit)/npats) / (exp(cc)/sum(pats))
      patsAdd <- sum(pats)*1/eff-sum(pats)
      dat <- matrix(c(sum(pats),eff*100,patsAdd), nrow=3, byrow=T)
    }

  } else {
    dat <- matrix(NA, nrow = 3, byrow = TRUE)
  }
  return(dat)
}

#' doseDesign module ui function
#'
#' @description A shiny Module for the doseDesign-tab in dosedesignR.
#'
#' @param id Internal parameters for {shiny}.
#'
#' @noRd
#'
#' @importFrom shiny NS tagList

doseDesignUI <- function(id) {
  dosedesignR_green <- "#5cb85c"
  dosedesignR_blue <- "#3a6791"
  dosedesignR_red <- "#c94053"
  ns <- shiny::NS(id)

  shiny::tagList(
    shiny::column(4,
      shinyBS::bsCollapse(
        shinyBS::bsCollapsePanel(title = paste0("Candidate Model ", as.character(id)),
         shiny::selectInput(
           inputId = ns("model"),
           label = NULL,
           choices = c(
             "Linear", "Emax", "Sigmoidal Emax"
            ),
            selected = rep(
              c(
                "Linear", "Emax", "Sigmoidal Emax"
              ), as.numeric(id)
            )[as.numeric(id)]
          ),
          shiny::textOutput(ns("model")),
          shiny::column(4,
            shinyWidgets::materialSwitch(
              ns("parambox"),
              HTML('<p style="color:white"> Show Parameter </p>'),
              value = TRUE,
              status = "success"
            )
          ),
          shiny::column(4,
            shinyWidgets::materialSwitch(
              ns("paramesti"),
              HTML('<p style="color:white"> Show Estimates </p>'),
              value = TRUE,
              status = "success"
            )
          ),
          shiny::column(4,
            shinyWidgets::materialSwitch(
              ns("plot_opt"),
              HTML(
                '<p style="color:white"> Show Optimal Curve </p>'
              ),
              value = TRUE,
              status = "success"
            )
          ),
          shiny::column(10,
            shiny::tableOutput(ns("showEstimates")),
            shiny::tags$head(
              shiny::tags$style(
                "#ShowEstimates td{position:relative;};"
              )
            )
          ),
          shiny::column(12,
            shiny::column(6,
              shiny::numericInput(ns("parameter1"),
              label = "",
              value = rep(0,100)[as.numeric(id)])
            ),
            shiny::column(6,
              shiny::numericInput(ns("parameter2"),
              label = "",
              value = rep(1,100)[as.numeric(id)])
            )
          ),
          shiny::column(12,
            shiny::column(6,
              shiny::numericInput(ns("parameter3"),
              label = "",
              value = rep(0.5,100)[as.numeric(id)])
            ),
            shiny::column(6,
              shiny::numericInput(ns("parameter4"),
              label = "",
              value = rep(5,100)[as.numeric(id)])
            )
          ),
          shiny::column(12,
            shiny::actionButton(
              ns("go_stand"),
              "Standardize",
              icon = icon("chart-line"),
              style = paste0("color: #fff; background-color: ", dosedesignR_blue, "; border-color: #2e6da4")
            ),
            shiny::actionButton(
              ns("undoButton"),
              "Undo Standardize!",
              icon = icon("undo"),
              style = paste0("color: #fff; background-color: ", dosedesignR_blue, "; border-color: #2e6da4")
            )
          ),
          shiny::tabsetPanel(type = "tabs",
            shiny::tabPanel("Plot",
              shiny::column(12, style = "background-color:#383838;",
              shiny::plotOutput(ns("modelFunction"), width = "100%")
              )
            ),
            shiny::tabPanel("Simulation",
              simModule_UI(paste0("s",id))
            )
          ),
          shiny::column(12,
            style = "background-color:#383838;",
            shiny::plotOutput(ns("optDesign"))
          ),
          shiny::column(12, align = "center",
            shiny::wellPanel(style = "background: #333333; border: black",
              shiny::tableOutput(ns("viewOpt"))
            )
          ),
          shiny::column(12,
            # call module from file 'doseLevel_Module.R' to enter dose
            # groups and dose levels
            doseLevelUI(ns("oM1"))
          ),
          shiny::column(12, align = "center",
            shiny::wellPanel(style = "background: #333333; border: black",
            shiny::tableOutput(ns("viewEff")))
          )
        ), id = paste0("Tab", as.character(id)),
        # let only the first 2 tabs be open at the start
        open = paste0("Candidate Model ", as.character(id))
     )
    )
  )
}

#' doseDesign module server function
#'
#' @param input,output,session Internal parameters for {shiny}.
#' @param nr panel number
#' @param levels level information (from app)
#' @param regimen regimen information (from app)
#' @param npats number of patients (from app)
#' @param dmin dose minimum (from app)
#' @param dmax dose maximum (from app)
#' @param ymin y-axis minimum (from app)
#' @param ymax y-axis maximum (from app)
#' @param sdsim simulation options (from app)
#' @param clevel level information (from app)
#' @param data data set (from app)
#' @param data2 second data set
#' @param selectnr Which data set (if multiple in .rds file) are selected
#' @param button save.button click
#' @param nrPanel total number of panels
#' @noRd
doseDesign <- function(
  input,
  output,
  session,
  nr,  # numeric value: panel number
  levels,
  regimen,
  npats,
  dmin,  # dose minimum
  dmax,  # dose maximum
  ymin,  # y axis minimum
  ymax,  # y axis maximum
  sdsim, # simulation options
  clevel,# level inforation
  data,  # df()
  data2, # da()
  selectnr, # which data sets (if multiple in .rds file) are selected
  button,   # save.button click
  nrPanel # total number of panels
  ){

  #condition that the switchInputs are only shown when a data set is loaded data2()
  shiny::observeEvent(c(data2(), input$paramesti), {
    if (!is.null(data2())) {
      shinyjs::show("paramesti")
      if (input$paramesti) {
      shinyjs::show("showEstimates")
      } else {
        shinyjs::hide("showEstimates")
      }
      shinyjs::show("plot_opt")
    } else {
      shinyjs::hide("paramesti")
      shinyjs::hide("plot_opt")
    }
  })

  # hide the parameters if switchInput parambox is false and
  # limit the number of parameter shown for the selected model if parambox is true
  shiny::observeEvent(c(input$model,input$parambox),  {
    if (input$parambox) {
      shinyjs::show("parameter1")
      shinyjs::show("parameter2")
      if (input$model %in% c('Linear', 'Linear in log')) {
        shinyjs::hide("parameter3")
        shinyjs::hide("parameter4")
      } else if (input$model %in% c('Emax')) {
        shinyjs::show("parameter3")
        shinyjs::hide("parameter4")
      } else {
        shinyjs::show("parameter3")
        shinyjs::show("parameter4")
      }
    } else {
      shinyjs::hide("parameter1")
      shinyjs::hide("parameter2")
      shinyjs::hide("parameter3")
      shinyjs::hide("parameter4")
    }
  })

  # call module from file 'doseLevel_Module.R' to enter dose
  # groups and dose levels
  oM <- shiny::callModule(doseLevel, "oM1")

  optValue <- shiny::reactiveValues()
  UserValue <- shiny::reactiveValues()

  # create reactive value start$dat which is set to TRUE if a data set was read in
  start <- shiny::reactiveValues(dat = FALSE)
    shiny::observeEvent(data2(), {
    if (!is.null(data2())) {
      start$dat <- TRUE
    }
  })

  output$flag <- shiny::reactive(start$dat)
  shiny::outputOptions(output, "flag", suspendWhenHidden = FALSE)

  output$optDesign <- shiny::renderPlot({
    # Make sure that enough dose levels are supplied
    tmp1 <- as.numeric(strsplit(levels(), ";")[[1]])

    if (regimen() == "Specify dose levels" & length(tmp1) > 0 & input$model == "Linear" )
      shiny::validate(need(length(tmp1) > 1, 'Need at least 2 dose levels'))
    if (regimen() == "Specify dose levels" & length(tmp1) > 0 & input$model == "Emax" ) {
      shiny::validate(need(length(tmp1) > 2, 'Need at least 3 dose levels'))
    }
    if (regimen() == "Specify dose levels" & length(tmp1) > 0 & input$model == "Sigmoidal Emax" )
      shiny::validate(need(length(tmp1) > 3, 'Need at least 4 dose levels'))

    # error messages for some parameters if parameters are negative
    if (input$model == "Emax" ) {
      shiny::validate(need(input$parameter2 > 0, 'For model Emax entries needs to be positive. Please select a value >0 for parameter ED50'))
    }
    if (input$model == "Sigmoidal Emax" ) {
      shiny::validate(need(input$parameter2 > 0, 'For model Emax Sigmoidal entries needs to be positive. Please select a value >0 for parameter ED50'))
      shiny::validate(need(input$parameter4 > 0, 'For model Emax Sigmoidal entries needs to be positive. Please select a value >0 for parameter Hill'))
    }

    # use function 'ComputeOptimal' from Optimization.R file
    x <- ComputeOptimal(input, levels = levels() , regimen = regimen(), dmin = dmin(), dmax = dmax())
    optValue$doses1 <- x$res[1,]
    optValue$distr1 <- x$res[2,]
    optValue$pats1  <- round(x$res[2, ] * npats(), 1)
    optValue$mods1 <- x$mods
    optValue$optD1 <- x$optD

    da <- data.frame(optValue$doses1, optValue$pats1)
    op <- c("optimal design")

    pl1 <- ggplot2::ggplot(
        data = da, aes(x = optValue$doses1, y = optValue$pats1, group = 1)
      ) +
      ggplot2::theme_minimal() +
      ggplot2::theme(
        plot.background = ggplot2::element_rect(fill = "#383838")
      ) +
      ggplot2::theme(
        legend.position = "none",
         axis.text = ggplot2::element_text(colour = "white"),
         panel.border = ggplot2::element_blank(),
         panel.grid.major = ggplot2::element_line(colour = "#474747"),
         panel.grid.minor = ggplot2::element_line(colour = "#474747", size = 0.25),
         text = ggplot2::element_text(
           family = "",
           face = "plain",
           colour = "white",
           size = 12,
           lineheight = 0.9,
           hjust = 0.5,
           vjust = 0.5,
           angle = 0,
           margin = margin(),
           debug = FALSE
         )
      ) +
      ggplot2::geom_linerange(
        ymin = 0,
        ymax = optValue$pats1,
        color = dosedesignR_red,
        lwd = 1.2
      ) +
      ggplot2::labs(x = "Dose", y = "Patients") +
      ggplot2::ylim(0, npats() * 0.7) +
      ggplot2::xlim(dmin(), dmax()) +
      ggplot2::theme(
        axis.text = ggplot2::element_text(size = rel(1.1)),
        axis.title = ggplot2::element_text(size = rel(1.1))
      ) +
      ggplot2::scale_colour_manual(values = c("white")) +
      ggplot2::theme(
        legend.text = ggplot2::element_text(size = rel(1.1)),
        legend.key = ggplot2::element_rect(size = 5),
        legend.margin = margin(l = -10),
        legend.position = "bottom",
        legend.title = ggplot2::element_blank()
      ) +
      ggplot2::guides(
        colour = guide_legend(override.aes = list(size = 1, alpha = 1, linetype = 1))
      )

    UserValue$doses1 <- oM()$dose
    UserValue$pats1 <- oM()$patients

    if (length(UserValue$doses1) == length(UserValue$pats1) && length(UserValue$pats1) > 0) {
      op <- c("optimal design", "user defined design")
      plotdat2 <- data.frame(doses = UserValue$doses1, pats = UserValue$pats1)

      pl1 <- ggplot2::ggplot(
          data = da,
          ggplot2::aes(
            x = optValue$doses1,
            y = optValue$pats1,
            group = 1
          )
        ) +
        ggplot2::geom_linerange(
          ymin = 0,
          ymax = optValue$pats1,
          color = dosedesignR_red,
          lwd = 1.2
        ) +
        ggplot2::theme_minimal() +
        ggplot2::theme(plot.background = element_rect(fill = "#383838")) +
        ggplot2::theme(
          legend.position = "none",
          axis.text = ggplot2::element_text(colour = "white"),
          panel.border = ggplot2::element_blank(),
          panel.grid.major = ggplot2::element_line(colour = "#474747"),
          panel.grid.minor = ggplot2::element_line(colour = "#474747", size = 0.25),
          text = ggplot2::element_text(
            family = "",
            face = "plain",
            colour = "white",
            size = 12,
            lineheight = 0.9,
            hjust = 0.5,
            vjust = 0.5,
            angle = 0,
            margin = margin(),
            debug = FALSE
          )
        ) +
        ggplot2::labs(x = "Dose", y = "Patients") +
        ggplot2::ylim(0, npats() * 0.7) +
        ggplot2::theme(
          axis.text = element_text(size = rel(1.1)),
          axis.title = element_text(size = rel(1.1))
        )

      pl1 <- pl1 +
        ggplot2::geom_point(
          data = plotdat2,
          ggplot2::aes(x = plotdat2$doses, y = plotdat2$pats, group = 1),
          colour = dosedesignR_green,
          size = rel(2)
        ) +
        ggplot2::xlim(
          dmin(), dmax()
        ) +
        ggplot2::scale_colour_manual(
          values = c("black", "#89D329")) +
          ggplot2::theme(
            legend.text = element_text(size = rel(1.1)),
            legend.key = element_rect(size = 5),
            legend.margin = margin(l = -10),
            legend.position = "bottom",
            legend.title = element_blank()
          ) +
          ggplot2::guides(
            colour = ggplot2::guide_legend(
              override.aes = list(
                size = c(1, 2.5),
                alpha = 1,
                shape = c(NA, 16),
                linetype = c(1, 0)
              )
            )
          )
    }
    suppressWarnings(print(pl1))
  })

  if (!is.null(data2())) {
    output$showEstimates <- shiny::renderTable({

      data2 <- data2()[selectnr()]
      if (input$model == "Linear") {
        tmp <- lapply(data2, function(x) {
          as.data.frame(t(DoseFinding::fitMod(x$df$dose, x$df$response, model = "linear")$coefs))
        })
        tmp2 <- lapply(tmp, function(x) {
          data.frame("Intercept" = c(input$parameter1, round(as.numeric(x[1]), 2)), "Slope" = c(input$parameter2, round(as.numeric(x[2]), 2)))})
      }
      if (input$model == "Emax") {
        tmp <- lapply(data2, function(x) {
          as.data.frame(t(DoseFinding::fitMod(x$df$dose, x$df$response, model = "emax", bnds = defBnds(max(x$df$dose))$emax)$coefs))
         })
        tmp2 <- lapply(tmp,function(x) {
          data.frame("E0" = c(input$parameter1, round(as.numeric(x[1]), 2)),
                     "ED50" = c(input$parameter2, round(as.numeric(x[3]), 2)),
                     "Emax" = c(input$parameter3, round(as.numeric(x[2]), 2)))
          })
      }
      if (input$model == "Sigmoidal Emax") {
        tmp <- lapply(data2, function(x){
          as.data.frame(t(DoseFinding::fitMod(x$df$dose, x$df$response, model = "sigEmax", bnds = defBnds(max(x$df$dose))$sigEmax)$coefs))
          })
        tmp2 <- lapply(tmp, function(x) {
          data.frame(
            "E0" = c(input$parameter1, round(as.numeric(x[1]), 2)),
            "ED50" = c(input$parameter2, round(as.numeric(x[3]), 2)),
            "Emax" = c(input$parameter3,round(as.numeric(x[2]), 2)),
            "Hill" = c(input$parameter4, round(as.numeric(x[4]), 2)))
        })
      }

      if (length(tmp2) > 0) {
        tmp2 <- rbind.data.frame(tmp2[[1]][1, ], do.call(rbind.data.frame, lapply(tmp2, function(x) data.frame(do.call(cbind.data.frame, x[2, ]), check.names = FALSE))))

        tmp2[1, ] <- paste0("<div style='width: 100%; height: 100%; z-index: 0;color: ", dosedesignR_red,";  '><span> ", tmp2[1, ], "</span></div>")
        for(i in 2:(dim(tmp2)[1])){
            tmp2[i, ] <- paste0("<div style='width: 100%; height: 100%; z-index: 0;color: ", data2()[[selectnr()[i - 1]]]$df$color[1], "; '><span> ", tmp2[i, ], "</span></div>")
        }

        tmp2

      }

    }, sanitize.text.function = function(x) x
  )}

  # Plot for the Plot Tab
  output$modelFunction <- shiny::renderPlot({
    shiny::validate(need(ymin() < ymax() , 'Maximum response needs to be greater than minimum response.'))

    # use the 'ComputeModelFunction' function from the Visualize.R file
    plotres <- ComputeModelFunction(
      input = input,
      tab = 1,
      ymin = ymin(),
      ymax = ymax(),
      dmin = dmin(),
      dmax = dmax(),
      data = data(),
      data_esti = data2(),
      plot_opt = input$plot_opt,
      selectnr = selectnr()
    )
    suppressWarnings(print(plotres))
  })

  # Table of dose levels
  output$viewOpt <- shiny::renderTable({
    dat <- matrix(c(optValue$doses1, round(optValue$pats1, 1)), nrow = 2, byrow = T)
    colnames(dat) <- NULL
    rownames(dat) <- c("Dose", "Patients")
    dat
  }, digits = 1, align = NULL, rownames = TRUE, colnames = FALSE)


  output$viewEff <- shiny::renderTable({
    # use the 'ComputeEfficiency' function from the Optimization.R file
    dat <- ComputeEfficiency(UserValue, optValue, input, 1, npats = npats())

    if (dim(dat)[1] == 3 & dim(dat)[2] == 1) {
    colnames(dat) <- NULL
    rownames(dat) <- c("Patients", "Efficiency [%]", "Additional patients needed")
    } else if (dim(dat)[1] == 1 & dim(dat)[2] == 1) {
      colnames(dat) <- NULL
      rownames(dat) <- c("Information:")
    }
    dat
  }, digits = 1, align = NULL, rownames = TRUE, colnames = FALSE)

  #  update the labels of the numeric input's depending on the selected model
  shiny::observeEvent(input$model, {
    if (input$model == "Linear") {
      shiny::updateNumericInput(session, "parameter1", label = "Intercept")
      shiny::updateNumericInput(session, "parameter2", label = "Slope")
    } else if (input$model == "Emax") {
      shiny::updateNumericInput(session, "parameter1", label = "E0")
      shiny::updateNumericInput(session, "parameter2", label = "ED50")
      shiny::updateNumericInput(session, "parameter3", label = "Emax")
    } else if (input$model == "Sigmoidal Emax") {
      shiny::updateNumericInput(session, "parameter1", label = "E0")
      shiny::updateNumericInput(session, "parameter2", label = "ED50")
      shiny::updateNumericInput(session, "parameter3", label = "Emax")
      shiny::updateNumericInput(session, "parameter4", label = "Hill")
    }
  })

  #### create undo button for the standardize button ####
  undo <- shiny::eventReactive(input$go_stand, {
    tmp <- c(
      shiny::isolate(input$parameter1),
      shiny::isolate(input$parameter2),
      shiny::isolate(input$parameter3),
      shiny::isolate(input$parameter4)
    )
    tmp
  })


  shiny::observeEvent(input$undoButton, {
    shiny::req(undo())
    tmp <- undo()
    shiny::updateNumericInput(session, "parameter1", value = tmp[1])
    shiny::updateNumericInput(session, "parameter2", value = tmp[2])
    shiny::updateNumericInput(session, "parameter3", value = tmp[3])
    shiny::updateNumericInput(session, "parameter4", value = tmp[4])
  })
  # Standardize Button
  shiny::observeEvent(input$go_stand, {
    req(undo())
    if (!is.null(input$model)) {

      if (input$model == "Linear") {
        if (!is.null(optValue$doses1)) {
          tmp <- DoseFinding::Mods(
            linear = NULL,
            maxEff = ymax(),
            doses = optValue$doses1,
            placEff = 0
          )
          shiny::updateNumericInput(session, "parameter2", value = as.numeric(tmp$linear[2]))
        }
      }

      if (input$model == "Emax") {
        if (!is.null(optValue$doses1)) {
          tmp <- DoseFinding::Mods(
            emax = input$parameter2,
            maxEff = ymax(),
            doses = optValue$doses1,
            placEff = 0
          )
          shiny::updateNumericInput(session,"parameter3", value = as.numeric(tmp$emax[2]))
        }
      }

      if (input$model == "Sigmoidal Emax") {
        if (!is.null(optValue$doses1)) {
          tmp <- DoseFinding::Mods(
            sigEmax = c(input$parameter2, input$parameter4),
            maxEff = ymax(),
            doses = optValue$doses1,
            placEff = 0
          )
          shiny::updateNumericInput(session, "parameter3", value = as.numeric(tmp$sigEmax[2]))
        }
      }
    }
  })

  # reactive object 'settings' to save all parameters
  # could be reduced without the model distinctive
  settings <- shiny::reactive({
    nrPanel()
    button()
    shiny::req(shiny::isolate(input$model), nrPanel())
    list(
      'model' = input$model,
      'parameter' = c(
        shiny::isolate(input$parameter1),
        shiny::isolate(input$parameter2),
        shiny::isolate(input$parameter3),
        shiny::isolate(input$parameter4)
      ),
      'levels' = oM(),
      'showParameter' = input$parambox
    )
  })

  return(
    list(
      parameter1 = shiny::reactive({input$parameter1}),
      parameter2 = shiny::reactive({input$parameter2}),
      parameter3 = shiny::reactive({input$parameter3}),
      parameter4 = shiny::reactive({input$parameter4}),
      send_design_button = shiny::reactive({input$send_design}),
      optValdoses = shiny::reactive({optValue$doses1}),
      optValpats = shiny::reactive({optValue$pats1}),
      UserValdoses = shiny::reactive({UserValue$doses1}),
      UserValpats = shiny::reactive({UserValue$pats1}),
      model  = shiny::reactive({input$model}),
      setting = shiny::reactive({settings()})
    )
  )
}

#required R libraries
suppressMessages(library(shiny))
suppressMessages(library(DT))
suppressMessages(library(DoseFinding))
suppressMessages(library(latticeExtra))
suppressMessages(library(ggplot2))
suppressMessages(library(shinyjs))
suppressMessages(library(stringr))
suppressMessages(library(shinyWidgets))
suppressMessages(library(shinyBS))
suppressMessages(library(readxl))
suppressMessages(library(knitr))
suppressMessages(library(kableExtra))


# global options
colortagdosdesR <- shiny::getShinyOption(
  "colortagdosdesR", "body {background-color: #424242 ; color: #828282 }"
)

initial_value <- 4

numberCandidateModels <- shiny::getShinyOption("numberCandidateModels", initial_value)

dosedesignR_green <- "#5cb85c"
dosedesignR_blue <- "#3a6791"
dosedesignR_red <- "#c94053"
dosedesignR_bright_grey <- "#424242"
dosedesignR_mid_grey <- "#383838"
dosedesignR_dark_grey <- "#333333"
f_col <- colorRamp(c(dosedesignR_blue, "gray89", dosedesignR_green))
f_col_report <- colorRamp(c(dosedesignR_blue, "gray42", dosedesignR_green))


DFApp <- shiny::shinyApp(
  #### UI ####
  ui <- shiny::fluidPage(
    shiny::tags$head(
      shiny::tags$style(
        shiny::HTML(
          ".shiny-notification {
          position:fixed;
          top: calc(57%);
          left: calc(3%);
          width: 350px;
          font-size: 30px;
          background-color: white;
          font-color: black;
          color: #424242;
          }"
        )
      )
    ),
    shiny::fluidRow(
      shiny::column(2,
        img(src = 'www/Iconx_dosedesignR.png', width = '100%'),
        shiny::div(
          shiny::tags$head(
            shiny::tags$style(
              HTML(
                "
                h1 {
                font-family: 'Arial';
                font-weight: 500;
                line-height: 1.5;
                color: #ffffff;
                }
                "
              )
            )
          )
        ),
        #### SIDEBAR PANEL ####
        #### ... 1. Data/Tab options ####
        shinyBS::bsCollapse(
          shinyBS::bsCollapsePanel("Data/Tab options",
           shiny::wellPanel(style = "background: #424242; border-color:#383838",
              shinyWidgets::prettyRadioButtons(
                inputId = 'impswitch',
                label = HTML('<p style = "color:white"> Select file format </p>'),
                status = "primary",
                shape = 'round',
                animation = 'smooth',
                choiceNames = list(tags$span(style = "color:white", "*.RDS file"),
                tags$span(style = "color:white", "*.csv file"),
                tags$span(style = "color:white", "*.xls(x) file")),
                choiceValues = c('rds', 'csv','xls')
              ),
              shiny::uiOutput('impdata'),
              shiny::uiOutput("datasets"),
              shiny::uiOutput("update_datasets")
            ),
            shiny::tags$div(shiny::tags$br()),
            shiny::wellPanel(style = "background: #424242; border-color:#383838",
              shiny::downloadButton(
                outputId = "save_setting2",
                label = "Save Settings ",
                style = paste0("color:#FFFFFF ; background-color: ", dosedesignR_blue, ";")
              ),
              shiny::tags$div(shiny::tags$br()),
              shiny::uiOutput('load_data'),
              shiny::tags$div(shiny::tags$br())
            )
          ), id = "collapse1", open = "Data/Tab options"
        ),
        #### ... 2. Display Options ####
        shinyBS::bsCollapse(
          shinyBS::bsCollapsePanel(title = "Display Options",
            shiny::numericInput(
              inputId = "ymin",
              label = HTML('<p style="color:white"> Minimum response </p>'),
              value = 0
            ),
            shiny::numericInput(
              inputId = "ymax",
              label = HTML('<p style="color:white"> Maximum response </p>'),
              value = 100
            ),
            shinyjs::disabled(
              numericInput(
                inputId = "dmin",
                label = HTML('<p style="color:white"> Minimum dose </p>'),
                value = 0)
            ),
            shiny::numericInput(
              inputId = "dmax",
              label = HTML('<p style="color:white"> Maximum dose </p>'),
              value = 100
            )
          ), id = "collapse2", open = "Display Options"
        ),
        #### ... 3. Design Options ####
        shinyBS::bsCollapse(
          shinyBS::bsCollapsePanel(title = "Design Options",
            shiny::numericInput(
              inputId = "npats",
              label = HTML('<p style="color:white"> Number of patients </p>'),
              value = 100
            ),
            shiny::selectInput(
              inputId = 'regimen',
              label = HTML('<p style="color:white"> Dose restrictions </p>'),
              choices = c("Min and max dose only", "Specify dose levels")
            ),
            shiny::textInput(
              inputId = "levels",
              label = HTML('<p style="color:white"> Dose levels</p>'),
              placeholder = "0;10;50;100"
            ),
            shinyjs::disabled(
              selectInput(
                inputId = 'optimality',
                label = HTML('<p style="color:white"> Optimality criterion </p>'),
                choices = c("A-Optimality", "D-Optimality", "E-Optimality", "G-Optimality"),
                selected = "D-Optimality"
              )
            )
          ), id = "collapse3", open = "Design Options"
        ),
        #### ... 4. Simulation Options ####
        shinyBS::bsCollapse(
          shinyBS::bsCollapsePanel(
            title = "Simulation Options",
            shiny::numericInput(
              inputId = "sdsim",
              label = HTML('<p style="color:white"> SD for simulation </p>'),
              value = 10,
              min = 0
            ),
            shiny::numericInput(
              inputId = "clevel",
              label = HTML('<p style="color:white"> Confidence level [%] </p>'),
              value = 95,
              min = 0,
              max = 100
            )
          ), id = "collapse4", open = "Simulation Options"
        ),
        #### ... 5. Report ####
        shinyBS::bsCollapse(
          shinyBS::bsCollapsePanel(title = "Report",
            shinyWidgets::checkboxGroupButtons(
              inputId = "report_selection",
              label = HTML('<p style="color:white"> Include Option(s): </p>'),
              choices = c(
                "General Options",
                "Optimal Design",
                "Simulation",
                "Session Info"
              ),
              selected = c("General Options", "Optimal Design", "Simulation", "Session Info"),
              justified = FALSE,
              status = "primary",
              checkIcon = list(yes = icon("ok", lib = "glyphicon"), no = icon("remove", lib = "glyphicon"))
            ),
            shinyWidgets::checkboxGroupButtons(
              inputId = "report_tabs",
              label = HTML('<p style="color:white"> Include Candidate Tab(s):</p>'),
              choices = paste0("Candidate Tab ", 1:numberCandidateModels),
              justified = FALSE,
              status = "primary",
              checkIcon = list(yes = icon("ok", lib = "glyphicon"), no = icon("remove", lib = "glyphicon"))
            ),
            shiny::conditionalPanel('output.include_tab_flag',
              shiny::selectInput(
               inputId = "outFormat",
               label = "Report format",
               choices = list(
                 html = "html_document",
                 Word = "word_document"
                )
              ),
              shiny::downloadButton(
                outputId = "report",
                label = "Generate report",
                class = "button_class"),
            ),
            shiny::tags$head(tags$style(".button_class{color: white; background-color: #5cb85c}"))
          ), id = "collapse5"
        )
      ),
      #### MAIN PANEL ####
      shiny::column(10,
        shiny::tabsetPanel(id = "tabSet_Panel_id",
          #### ... 1. Dose Finding ####
          shiny::tabPanel("Dose Finding", value = 1,
            shinyjs::useShinyjs(),
            list(
              shiny::tags$head(shiny::tags$style(colortagdosdesR))
            ),
            shiny::tags$style(type = 'text/css',
              HTML(
                paste0(".panel-default > .panel-heading {color: #fff; background-color: ", dosedesignR_blue, ";}",
                ".panel-default {border-color: #383838}",
                ".panel-group .panel {background-color: #383838}",
                ".panel-default > .panel-heading + .panel-collapse > .panel-body {border-top-color: #424242}",
                ".panel-title {font-weight: bold}
                ")
              )
            ),
            shiny::mainPanel(width = 12,
              shiny::uiOutput('numModUI')
            )
          ),
          #### ... 3. Help ####
          shiny::navbarMenu("Help",
            #### ..... 3.1. Dose Design ####
            shiny::tabPanel("Dose Design", value = 3,
              shiny::uiOutput('manual_dosedesign')
            ),
            #### ..... 3.2. Data Structure ####
            shiny::tabPanel("Data Structure", value = 4,
             shiny::uiOutput('manual')
            )
          )
        )
      )
    )
  ),
  #### SERVER ####
  server <- function(input, output, session) {
    if (exists("apppars")) {
      numberCandidateModels <- apppars$numberCandidateModels
    } else {
      numberCandidateModels <- shiny::getShinyOption(
          "numberCandidateModels", numberCandidateModels
        )
    }
    #### SIDEBAR PANEL ####
    #### ... 1. Data/Tab Options ####
    output$load_data <- shiny::renderUI({
      shiny::fileInput(
        inputId = 'loadSettings',
        label = HTML('<p style="color:white"> Upload Settings (.rds) </p>'),
        multiple = FALSE,
        accept = '.RData'
      )
    })

    output$impdata <- shiny::renderUI({
      if (input$impswitch == 'rds') {
        shiny::fixedRow(
          shiny::column(12,
            shiny::fileInput(
              inputId = 'file',
              label = HTML('<p style="color:white"> Choose RDS file </p>'),
              multiple = FALSE,
              accept = '.RData'
            )
          )
        )
      } else if (input$impswitch == 'xls') {
        shiny::fixedRow(
          shiny::column(12,
            shiny::fileInput(
              inputId = 'xls',
              label = HTML('<p style="color:white"> Choose Excel file </p>'),
              multiple = FALSE,
              accept = '.xls,.xlsx'
            )
          )
        )
      } else if (input$impswitch == 'csv') {
        shiny::tagList(
          shiny::fixedRow(
            shiny::column(12,
              shiny::radioButtons(
                inputId = 'sep',
                label = HTML('<p style="color:white"> Select separator </p>'),
                inline = FALSE,
                choices = c(
                  'Comma' = ',',
                  'Semicolon' = ';',
                  'Tab' = '\t'
                ),
                selected = ','
              )
            ),
            shiny::column(12,
              shiny::radioButtons(
                inputId = 'quote',
                label = HTML('<p style="color:white"> Select quote </p>'),
                inline = FALSE,
                choices = c(
                  None = '',
                  'Double Quote (")' = '"',
                  "Single Quote (')" = "'"
                ),
                selected = '"'
              )
            ),
            shiny::column(12,
              shiny::radioButtons(
                inputId = 'dec',
                label = HTML('<p style="color:white"> Select decimal character </p>'),
                inline = FALSE,
                choices = c(
                  'Point (.)' = '.',
                  'Comma (,)' = ','
                ),
                selected = '.'
              )
            ),
            shiny::column(12,
              shiny::fileInput(
                inputId = 'csv',
                label = HTML('<p style="color:white"> Choose CSV file </p>'),
                multiple = TRUE,
                accept = c(
                  'text/csv',
                  'text/comma-separated-values,text/plain',
                  '.csv'
                )
              )
            )
          )
        )
      }
    })

    output$impdataMod <- shiny::renderUI({
      shiny::fileInput(
        inputId = 'file',
        label = 'Choose RDS file',
         multiple = FALSE,
        accept = '.RData'
      )
    })

    df <- shiny::reactive({
      if (is.null(input$file) & is.null(input$csv) & is.null(input$xls)) {
        data1 <- NULL
      }
      if (!is.null(input$file)) {
        data1 <- readRDS(input$file$datapath)
        if (is.data.frame(data1)) {
          data1 <- list('data' = list(data1))
        } else if (is.list(data1)) {
          data1 <- list('data' = data1[1:length(data1)])
        }
        for (i in 1:length(data1$data)) {
          data_cols <- rgb(f_col(seq(0, 1, length = length(data1$data))), maxColorValue = 255)
          data_cols_report <- rgb(f_col_report(seq(0, 1, length = length(data1$data))), maxColorValue = 255)
          data1$data[[i]] <- cbind(data1$data[[i]], 'color' = data_cols[i], 'color_report' = data_cols_report[i])
        }
      }
      if (!is.null(input$xls)) {
        data1 <- readxl::read_excel(input$xls$datapath)
        if ("Modell" %in% colnames(data1)) {
          split_data1 <- split(data1, data1$Modell)

          empty_list <- list('data' = NULL)

          for (i in 1:length(split_data1)) {
            data_cols <- rgb(f_col(seq(0, 1, length = length(data1$data))), maxColorValue = 255)
            data_cols_report <- rgb(f_col_report(seq(0, 1, length = length(data1$data))), maxColorValue = 255)
            empty_list$data[[i]] <- cbind(split_data1[[i]], 'color' = data_cols[i], 'color_report' = data_cols_report[i])
          }
          data1 <- empty_list
        } else if(!("Modell" %in% colnames(data1))) {

        }
      }
      if (!is.null(input$csv)) {
        data1 <- utils::read.csv(
          input$csv$datapath,
          header = TRUE,
          na.strings = c('NA','.',''),
          sep = input$sep,
          quote = input$quote,
          dec = input$dec,
          stringsAsFactors = FALSE
        )
        if ("Modell" %in% colnames(data1)) {
          split_data1 <- split(data1, data1$Modell)
          empty_list <- list('data' = NULL)
          for (i in 1:length(split_data1)) {
            data_cols <- rgb(f_col(seq(0, 1, length = length(data1$data))), maxColorValue = 255)
            data_cols_report <- rgb(f_col_report(seq(0, 1, length = length(data1$data))), maxColorValue = 255)
            empty_list$data[[i]] <- cbind(split_data1[[i]], 'color' = data_cols[i], 'color_report' = data_cols_report[i])
          }
          data1 <- empty_list
        } else if (!("Modell" %in% colnames(data1))) {

        }
      }
      data1
    })


    output$update_datasets <- shiny::renderUI({
      shiny::req(df())
      shiny::actionButton(
        inputId = "update_datasets",
        label = "Update datasets",
        icon = icon("exchange-alt"),
        style = paste0("color:#FFFFFF ; background-color: #5cb85c;")
      )
    })

    output$datasets <- shiny::renderUI({
      shiny::req(df())
      dftmp <- df()
      choices <- paste0("Dataset ", 1:length(dftmp$data))

      choices.sym <- rep('glyphicon-plus-sign', length(dftmp$data))
      data_cols <- rgb(f_col(seq(0, 1, length = length(df()$data))), maxColorValue = 255)
      choices.col <- paste('color:', data_cols[1:length(dftmp$data)])

      uiElement <- shinyWidgets::pickerInput(
        'datasets',
        label = 'Datasets',
        choices = choices,
        multiple = TRUE,
        selected = NULL,
        options = list(
          `actions-box` = TRUE,
          `selected-text-format` = 'count > 0',
          `count-selected-text` = '{0} selected (of {1})',
          `live-search` = FALSE,
          `style` = 'background: btn-primary',
          `header` = 'Select multiple items',
          `none-selected-text` = 'Please select'
        ),
        choicesOpt = list(
          `icon` = choices.sym,
          `style` = choices.col
        )
      )
    })

    output$datasetsMod <- shiny::renderUI({
      shiny::req(df())
      dftmp <- df()
      choices <- paste0("Dataset ", 1:length(dftmp$data))

      choices.sym <- rep('glyphicon-plus-sign', length(dftmp$data))
      data_cols <- rgb(f_col(seq(0, 1, length = length(df()$data))), maxColorValue = 255)
      choices.col <- paste('color:', data_cols[1:length(dftmp$data)])

      uiElement <- shinyWidgets::pickerInput(
        'datasetsMod',
        label = 'Datasets',
        choices = choices,
        multiple = TRUE,
        selected = choices[1],
        options = list(
          `actions-box` = TRUE,
          `selected-text-format` = 'count > 0',
          `count-selected-text` = '{0} selected (of {1})',
          `live-search` = FALSE,
          `style` = 'background: btn-primary',
          `header` = 'Select multiple items',
          `none-selected-text` = 'Please select'
        ),
        choicesOpt = list(
          `icon` = choices.sym,
          `style` = choices.col
        )
      )
    })

    selectedData <- shiny::reactive({
      input$update_datasets
      if (!is.null(shiny::isolate(input$datasets))) {
        sD <- as.numeric(substr(shiny::isolate(input$datasets), 9, nchar(shiny::isolate(input$datasets))))
      } else {
        sD <- NULL
      }
      sD
    })

    da <- shiny::reactive({
      ds <- df()
      input$update_datasets
      if (!is.null(ds) & !is.null(shiny::isolate(input$datasets))) {
        da <- list()
        for(i in 1:length(ds$data)) {
          dt <- ds$data[[i]]
          dose_lev <- as.numeric(names(table(dt$dose)))
          # get the maximum dose
          dose_max <- max(as.numeric(names(table(dt$dose))))
          # get minimum and maximum response value
          response_min <- min(dt$response)
          response_max <- max(dt$response)

          da[[i]] <- list(
            'df' = dt,
            'dose_lev' = dose_lev,
            'dose_max' = dose_max,
            'response_min' = response_min,
            'response_max' = response_max
          )
        }
      } else {
        da <- NULL
      }
      da
    })

    shiny::observeEvent(selectedData(), {
      da <- da()
      sda <- selectedData()
      if (!is.null(da)) {
        if (!is.null(sda)) {
          shiny::updateNumericInput(
            session,
            "dmax",
            value = max(unlist(lapply(da[sda],function(x)(x$dose_max))))
          )
          shiny::updateNumericInput(
            session,
            "ymin",
            value = min(unlist(lapply(da[sda], function(x)(x$response_min))))
          )
          shiny::updateNumericInput(
            session,
            "ymax",
            value = max(unlist(lapply(da[sda], function(x)(x$response_max))))
          )
        }
      }
    })

    output$save_setting2 <- downloadHandler(
      filename = function() {
        paste("settings", ".rds", sep = "")
      },
      content = function(file) {
        saveRDS(settings(), file)
      }
    )

    settings <- shiny::reactive({
      #save information inside the modules from reactive object call_Mod()
      param <- list()
      levelsettings <- list()
      for (i in 1:length(call_Mod())) {
        param[[i]] <- call_Mod()[[i]]$setting()

      }
      selected <- c()
      openclosed <- c()
      for (i in 1:numberCandidateModels) {
        openclosed[i] <- ifelse(!is.null(input[[paste0("Tab", i)]]), "open", "close")
        selected[i] <- ifelse(!is.null(input[[paste0("Tab", i)]]),paste0("Candidate Tab ", i),NA)
      }

      selected <- selected[!is.na(selected)]

      # updateCheckboxGroupButtons()
      #save global settings from sidepanel
      global_Variables <- c(
        input$ymin,
        input$ymax,
        input$dmin,
        input$dmax,
        input$npats,
        input$regimen,
        input$levels,
        input$sdsim,
        input$clevel
      )
      #save all objects as a list and store it as dosedesignR_setting.rds file
      save <- list(
        'Number of parameter' = length(call_Mod()),
        'Parameter' = param,
        'Open Tabs' = openclosed,
        'Global Variables' = global_Variables,
        'Selected Tabs' = selected
      )
      save
    })

    shiny::observeEvent(input$loadSettings, {
      tmp <- readRDS(input$loadSettings$datapath)

      for (i in 1:length(tmp$Parameter)) {
        if (tmp$'Open Tabs'[i] == "open") {
          shinyBS::updateCollapse(session, paste0("Tab", i), open = paste0("Candidate Model ", i))
        }
        if (tmp$'Open Tabs'[i] == "close") {
          shinyBS::updateCollapse(session, paste0("Tab", i), close = paste0("Candidate Model ", i))
        }
      }
      for (i in 1:length(tmp$Parameter)) {
        shinyWidgets::updateMaterialSwitch(session, paste0(i,"-parambox"), value = tmp$Parameter[[i]]$showParameter)
        shiny::updateSelectInput(session, paste0(i, "-model"), selected = tmp$Parameter[[i]]$model)

        for (j in 1:4) {
          shiny::updateNumericInput(session, paste0(i, "-parameter", j), value = tmp$Parameter[[i]]$parameter[j])
        }
        if (!is.null(tmp$Parameter[[i]]$levels)) {
          for (k in 1:dim(tmp$Parameter[[i]]$levels)[1]){
            shiny::req(call_Mod())
            shiny::updateTextInput(session, paste0(i, "-oM1-tmp", k, "-level"), value = tmp$Parameter[[i]]$levels$dose[k])
            shiny::updateTextInput(session, paste0(i, "-oM1-tmp", k, "-patients"), value = tmp$Parameter[[i]]$levels$patients[k])
          }
        }
      }
      shiny::updateNumericInput(session, "ymin", value = tmp$'Global Variables'[1])
      shiny::updateNumericInput(session, "ymax", value = tmp$'Global Variables'[2])
      shiny::updateNumericInput(session, "dmin", value = tmp$'Global Variables'[3])
      shiny::updateNumericInput(session, "dmax", value = tmp$'Global Variables'[4])
      shiny::updateNumericInput(session, "npats", value = tmp$'Global Variables'[5])
      shiny::updateSelectInput(session, "regimen", selected = tmp$'Global Variables'[6])
      shiny::updateTextInput(session, "levels", value = tmp$'Global Variables'[7])
      shiny::updateNumericInput(session, "sdsim", value = tmp$'Global Variables'[8])
      shiny::updateNumericInput(session, "clevel", value = tmp$'Global Variables'[9])
    })

    #### ... 2. Display Options ####
    shiny::observeEvent(input$ymin, {
      shiny::updateNumericInput(session, "ymin", value = input$ymin)
      shiny::updateNumericInput(session, "yminMod", value = input$ymin)
    })

    shiny::observeEvent(input$yminMod, {
      shiny::updateNumericInput(session, "ymin", value = input$yminMod)
      shiny::updateNumericInput(session, "yminMod", value = input$yminMod)
    })

    shiny::observeEvent(input$ymax, {
      shiny::updateNumericInput(session, "ymax", value = input$ymax)
      shiny::updateNumericInput(session, "ymaxMod", value = input$ymax)
    })

    shiny::observeEvent(input$ymaxMod, {
      shiny::updateNumericInput(session,"ymax", value = input$ymaxMod)
      shiny::updateNumericInput(session,"ymaxMod", value = input$ymaxMod)
    })

    shiny::observeEvent(input$dmin, {
      shiny::updateNumericInput(session, "dmin", value = input$dmin)
      shiny::updateNumericInput(session, "dminMod", value = input$dmin)
    })

    shiny::observeEvent(input$dminMod, {
      shiny::updateNumericInput(session ,"dmin", value = input$dminMod)
      shiny::updateNumericInput(session ,"dminMod", value = input$dminMod)
    })

    shiny::observeEvent(input$dmax, {
      shiny::updateNumericInput(session ,"dmax", value = input$dmax)
      shiny::updateNumericInput(session ,"dmaxMod", value = input$dmax)
    })

    shiny::observeEvent(input$dmaxMod, {
      shiny::updateNumericInput(session ,"dmax", value = input$dmaxMod)
      shiny::updateNumericInput(session ,"dmaxMod", value = input$dmaxMod)
    })

    #### ... 3. Design Options ####
    shiny::observeEvent(input$npats, {
      shiny::updateNumericInput(session, "npats", value = input$npats)
      shiny::updateNumericInput(session, "npatsMod", value = input$npats)
    })

    shiny::observeEvent(input$npatsMod, {
      shiny::updateNumericInput(session, "npats", value = input$npatsMod)
      shiny::updateNumericInput(session, "npatsMod", value = input$npatsMod)
    })

    shiny::observeEvent(input$regimen, {
      shiny::updateSelectInput(session, "regimen", selected = input$regimen)
      shiny::updateSelectInput(session, "regimenMod", selected = input$regimen)
    })

    shiny::observeEvent(input$regimenMod,{
      shiny::updateSelectInput(session, "regimen", selected = input$regimenMod)
      shiny::updateSelectInput(session, "regimenMod", selected = input$regimenMod)
    })
    #### ... 4. Simulation Options ####
    #call Module simModule_Server
    shiny::observe({
      purrr::map(
        number_Module$val2, ~ shiny::callModule(
          simModule_Server,
          id = .x,
          number = 1,
          no = as.numeric(substr(.x, 2, nchar(.x))),
          levels = lev,
          regimen = regi,
          npats = npat,
          dmax = dma,
          dmin = dmi,
          ymin = ymi,
          ymax = yma,
          sdsim = sds,
          clevel = clev,
          inp = call_Mod
        )
      )
    })

    #### ... 5. Report ####
    include_tab_flag <- shiny::reactiveValues(val = FALSE)

    shiny::observe({
      if (is.null(input$report_tabs)) {
        include_tab_flag$val <- FALSE
      } else {
        include_tab_flag$val <- TRUE
      }
    })

    output$include_tab_flag <- shiny::reactive(include_tab_flag$val)

    shiny::outputOptions(output,"include_tab_flag", suspendWhenHidden = FALSE)

    output$report <- shiny::downloadHandler(filename = function() {
      switch(
        input$outFormat,
        html_document = paste("report",gsub(":","-",Sys.time()), ".html", sep = ""),
        word_document = paste("report",gsub(":","-",Sys.time()), ".docx", sep = "")
      )
      },
      content = function(file) {
        withProgress(message = 'Generating Report, please wait...', {
        tempReport <- file.path(tempdir(), "report.Rmd")
        file.copy("report.Rmd", tempReport, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "General_options.Rmd")
        file.copy("General_options.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "Optimal_design_Intro.Rmd")
        file.copy("Optimal_design_Intro.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "Optimal_design.Rmd")
        file.copy("Optimal_design.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "Simulation_Intro.Rmd")
        file.copy("Simulation_Intro.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "Simulation.Rmd")
        file.copy("Simulation.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "Overview_models_Intro.Rmd")
        file.copy("Overview_models_Intro.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "Overview_models_Intro2.Rmd")
        file.copy("Overview_models_Intro2.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "Overview_models.Rmd")
        file.copy("Overview_models.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "Session_info.Rmd")
        file.copy("Session_info.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "optimalContrast_power.Rmd")
        file.copy("optimalContrast_power.Rmd", tempReport_child, overwrite = TRUE)
        tempReport_child <- file.path(tempdir(), "Iconx_dosedesignR.png")
        file.copy("Iconx_dosedesignR.png", tempReport_child, overwrite = TRUE)

        # Set up parameters to pass to Rmd document
        params <- list(
          numberCandidateModels = numberCandidateModels,
          minimumResponse = input$ymin,
          maximumResponse = input$ymax,
          minimumDose = input$dmin,
          maximumDose = input$dmax,
          data = df(),
          data_name = input$file$name,
          data2 = da(),
          plot_opt = input$plot_opt,
          sdsim = input$sdsim,
          clevel = input$clevel,
          selectnr = selectedData(),
          npats = input$npats,
          call_Mod = call_Mod(),
          regimen = input$regimen,
          regimen_text = ifelse(input$regimen == "Min and max dose only","Only restricted between min and max dose",paste0("Restricted to the following doses: ",input$levels)),
          levels = input$levels,
          report_selection = input$report_selection,
          report_tabs = as.numeric(substr(input$report_tabs,15,17)),
          data_cols =  rgb(f_col_report(seq(0, 1, length = length(df()$data))), maxColorValue = 255),
          rendered_by_shiny = TRUE
        )

        for(i in as.numeric(substr(input$report_tabs, 15, 17))) {
          params[[paste0("model", i)]] <- input[[paste0(i,"-model")]]
          params[[paste0("param", i, "_1")]] <- input[[paste0(i,"-parameter1")]]
          params[[paste0("param", i, "_2")]] <- input[[paste0(i,"-parameter2")]]
          params[[paste0("param", i, "_3")]] <- input[[paste0(i,"-parameter3")]]
          params[[paste0("param", i, "_4")]] <- input[[paste0(i,"-parameter4")]]
          params[[paste0("Mod_model", i)]] <- input[[paste0("Mod",i,"-model")]]
          params[[paste0("Mod_param", i, "_1")]] <- input[[paste0("Mod",i,"-parameter1")]]
          params[[paste0("Mod_param", i, "_2")]] <- input[[paste0("Mod",i,"-parameter2")]]
          params[[paste0("Mod_param", i, "_3")]] <- input[[paste0("Mod",i,"-parameter3")]]
          params[[paste0("Mod_param", i, "_4")]] <- input[[paste0("Mod",i,"-parameter4")]]
          params[[paste0("user_chosen",i)]] <- ifelse(is.null(call_Mod()[[i]]$setting()$levels),NA, call_Mod()[[i]]$setting()$levels)
        }

        # Knit the document, passing in the `params` list, and eval it in a
        # child of the global environment (this isolates the code in the document
        # from the code in this app).
        rmarkdown::render(
          tempReport,
          output_file = file,
          params = params,
          output_format = input$outFormat,
          envir = new.env(parent = globalenv())
        )
        })
      }
    )

    shiny::observe({shinyWidgets::updateCheckboxGroupButtons(session, inputId = "report_tabs", selected =settings()$'Selected Tabs')})

    #### MAIN PANEL ####
    #### ... 1. Dose Finding ####
    # Calculate and Update the number of module id s
    number_Module <- shiny::reactiveValues(
      val = paste0(1:numberCandidateModels),
      val2 = paste0("s",1:numberCandidateModels),
      val3 = paste0("inp", 1:numberCandidateModels, " =call_Mod()[[", 1:numberCandidateModels, "]]")
    )

    shiny::observeEvent(input$nrPanels, {
      number_Module$val <- as.character(1 : isolate(input$nrPanels))
      number_Module$val2 <- paste0("s", as.character(1 : shiny::isolate(input$nrPanels)))
      number_Module$val3 <- paste0("inp", as.character(1 : shiny::isolate(input$nrPanels)) ,
                                   "= call_Mod()[[", as.character(1 : input$nrPanels),"]]")
    })

    # Call Module
    output$numModUI <- shiny::renderUI ({
      shiny::fluidRow(width = 12,
        purrr::map(number_Module$val, ~ doseDesignUI(id = .x))
      )
    })

    regi <- shiny::reactive({input$regimen})
    lev <- shiny::reactive({input$levels})
    npat <- shiny::reactive({input$npats})
    dmi <- shiny::reactive({input$dmin})
    dma <- shiny::reactive({input$dmax})
    ymi <- shiny::reactive({input$ymin})
    yma <- shiny::reactive({input$ymax})
    sds <- shiny::reactive({input$sdsim})
    clev <- shiny::reactive({input$clevel})
    butt <- shiny::reactive({input$save.setting})
    nrPan <- shiny::reactive({numberCandidateModels})

    # save Output from doseDesign Modul as a reactive object call_Mod()

    reactive_values_send_design <- shiny::reactiveValues(
      doses = NULL,
      patients = NULL
    )

    shiny::observeEvent(call_Mod()[[1]]$send_design_button(), {
      for (i in 1:length(call_Mod()[[1]]$UserValdoses())) {
        shiny::updateNumericInput(session, paste0("dM1-tmp",i,"-level"), value = call_Mod()[[1]]$UserValdoses()[i])
      }
      for (i in 1:length(call_Mod()[[1]]$UserValpats())) {
        shiny::updateNumericInput(session, paste0("dM1-tmp", i, "-patients"), value = call_Mod()[[1]]$UserValpats()[i])
      }
      reactive_values_send_design$doses <- call_Mod()[[1]]$UserValdoses()
      reactive_values_send_design$patients <- call_Mod()[[1]]$UserValpats()
    })
    shiny::observeEvent(call_Mod()[[2]]$send_design_button(), {
      for (i in 1:length(call_Mod()[[2]]$UserValdoses())) {
        shiny::updateNumericInput(session, paste0("dM1-tmp",i,"-level"), value = call_Mod()[[2]]$UserValdoses()[i])
      }
      for (i in 1:length(call_Mod()[[2]]$UserValpats())) {
        shiny::updateNumericInput(session, paste0("dM1-tmp", i, "-patients"), value = call_Mod()[[2]]$UserValpats()[i])
      }
      reactive_values_send_design$doses <- call_Mod()[[2]]$UserValdoses()
      reactive_values_send_design$patients <- call_Mod()[[2]]$UserValpats()
    })
    shiny::observeEvent(call_Mod()[[3]]$send_design_button(), {
      for (i in 1:length(call_Mod()[[3]]$UserValdoses())) {
        updateNumericInput(session, paste0("dM1-tmp",i,"-level"), value = call_Mod()[[3]]$UserValdoses()[i])
      }
      for (i in 1:length(call_Mod()[[3]]$UserValpats())) {
        updateNumericInput(session, paste0("dM1-tmp", i, "-patients"), value = call_Mod()[[3]]$UserValpats()[i])
      }
      reactive_values_send_design$doses <- call_Mod()[[3]]$UserValdoses()
      reactive_values_send_design$patients <- call_Mod()[[3]]$UserValpats()
    })

    send_reac <- shiny::reactive({
      data.frame(doses = reactive_values_send_design$doses, patients = reactive_values_send_design$doses)
    })

    output$send_design_table <- shiny::renderTable({
      send_reac()
    },
    bordered = TRUE,
    spacing = 'xs',
    rownames = TRUE,
    digits = 2
    )

    call_Mod <- shiny::reactive({
      Val <- purrr::map(number_Module$val, ~ shiny::callModule(
        doseDesign,
        id = .x,
        nr = as.numeric(.x),
        levels = lev,
        regimen = regi,
        npats = npat,
        dmax = dma,
        dmin = dmi,
        ymin = ymi,
        ymax = yma,
        sdsim = sds,
        clevel = clev,
        data = df,
        data2 = da,
        selectnr = selectedData,
        button = butt,
        nrPanel = nrPan
      )
      )
      Val
    })

    doses <- shiny::reactive({
      shiny::req(dM())
      doses <- dM()$dose
      doses
    })

    index1 <- shiny::reactive({
      index <- c()
      for (i in 1:numberCandidateModels) {
        index[i] <- ifelse(!is.null(input[[paste0("TabMod", i)]]), TRUE, FALSE)
      }
      index
    })

    # wrap an observer around the callModule because of the reactive expression number_Module$val
    shiny::observe({(call_Mod())})

    #### ..... 2.2. Design ####
    dM <- shiny::callModule(doseLevel, "dM1")
    shiny::observe({dM()})

    #### ... 3. Help ####
    #### ..... 3.1. Dose Design ####
    output$manual_dosedesign <- shiny::renderUI({
      list(
        HTML(
          "
          <h1 style='color: white'> dosedesignR </h1>
          <p style='color: white'>

          </p>
          <h3 style='color: white'> Description </h3>
          <p style='color: white'>
          The Shiny application dosedesignR provides the user with an interactive application which can be used to facilitate the planning of dose finding studies by applying the theory of optimal experimental design. The application visualizes dose-response curves, optimal designs and corresponding simulated realizations of dose-response studies.
          Functionality
          After loading the package dosedesignR, the application can be started by calling the function launch_dosedesignR()upon which the user interface opens. The user interface is split into two parts: a sidebar panel on the left side for specifying general options and the main panel for investigating different dose-response relationships.
          Left sidebar panel
          In the Options panel it is possible to specify the minimum and maximum response as well as the minimum and maximum dose relevant for the dose-response relationship. The default setting for the minimum dose is 0, corresponding to placebo, which cannot be changed. The response and dose options are mainly used for plotting, even though the maximum dose is also a design parameter.
          For the Design Options the total number of patients that should be distributed across the different dose levels determined by the optimal design can be entered. Furthermore, it is possible to choose between two different dose restrictions for the optimal design: Min and max dose only and Specify dose levels. For Min and max dose only the optimal design is derived on the continuous design space between the minimum and the maximum dose defined above. These designs are theoretically optimal and calculated exactly. For Specify dose levels specific dose levels need to be entered in the Dose levels panel beneath (separated by semicolon) and the optimal design is derived restricted to these entered dose levels. To find the optimal designs an optimization algorithm selects among all possible combinations of patients and dose levels. Additionally, the underlying optimality criterion for the calculation of the optimal design can be selected (in the current version this is restricted to D-Optimality). Lastly, one can specify the population standard deviation of the response and a confidence level. Both will be used for the simulations in the main panel.
          Main panel
          The main panel is again split up into three vertical subpanels, labeled as Candidate Model 1, Candidate Model 2 and Candidate Model 3. Thus it allows to simultaneously compare three different dose-response models. So far the linear model, the emax model and the sigmoidal emax model are implemented. Let  denote the dose within the specified dose range. Then the models are defined as follows
          ,
          ,
          .
          Here, denotes the dose,  is the placebo response, is the maximal treatment effect,  is the half effect dose, i.e. the dose at which half of the maximal effect is reached, and h is the Hill parameter which determines the steepness of the response increase/decrease.

          Each of the three vertical candidate panels consists of three parts: a top part to choose the model parameters and plot the corresponding dose-response curve, a middle part to visualize the optimal design and a bottom part in which a user-defined design can be compared with the optimal design.
          In the top part, the values of the respective model parameters can be entered in the Parameters tab. The Plot tab next to the Parameters tab visualizes the dose-response curve based on the chosen model and the corresponding model parameters.
          In the middle part, the optimal design based on the chosen dose-response model and corresponding parameter values is visualized by black vertical lines, taking into account the number of patients, the dose restrictions and the optimality criterion selected in the left sidebar panel. Additionally, the optimal design is tabulated underneath the plots.
          In the bottom part, a user defined design can be entered by specifying dose levels in the Dose levels input box and the corresponding number of patients in the Patients input box (separated by semicolon, respectively). The user defined design is additionally visualized in the optimal design plot by green dots. The user defined design is not bound by the dose restrictions selected in the left sidebar panel and dose levels apart from these could be specified. Underneath the input boxes for the user defined design the properties of the design in tabular form are shown. In the first line, the total number of patients entered is shown. In the second line the efficiency of the user defined design compared to the optimal design (under the chosen dose restrictions) is shown in percentage. In the last line this efficiency is converted to the number of patients which would additionally be needed to achieve the same precision in the parameter estimation (O'Quigley et al., 2017).
          By choosing the Simulation tab next to the Parameters and Plot tab in the top part of the panel, another plot appears. Here it is possible to visualize simulated realizations of dose-response measurements and the corresponding effect on the estimation of the dose-response curve. The underlying design, i.e. the dose levels and the number of patients per dose level, can be selected to be any of the three optimal designs or any of the three user defined designs specified in the three candidate model panels. Response realizations are randomly drawn from a normal distribution with mean equal to the value of the true curve and variance based on the population standard deviation specified in the left sidebar panel. The true and the estimated curve together with the corresponding confidence interval are shown. True curve here refers to the specified candidate model in the corresponding panel.
          </p>
          <h3 style='color: white'> Additional information </h3>
          <p style='color: white'>
          The application was optimized for display on a screen/projector with HD resolution.
          </p>
          <h3 style='color: white'> Disclaimer </h3>
          <p style='color: white'>
          The authors do not guarantee the accuracy of any results.
          </p>
          <h3 style='color: white'> Acknowledgements </h3>
          <p style='color: white'>
          The authors would like to thank the dose finding group within Bayer's Biostatistics Innovation Center [1].
          Besides other packages, we mainly used the DoseFinding [2] and the shiny [3] package.
          </p>
          <h3 style='color: white'> References </h3>
          <ul>
          <li>
          <p style='color: white'>
          Kulmann H., Muysers C., Dmitrienko A. and Roehmel J. (2016). The Biostatistics Innovation Center at Bayer. Biopharmaceutical  Report 23, 1-5. </li>
          </p>
          <li>
          <p style='color: white'>
          Bornkamp B., Pinheiro J. and Bretz F. (2016). DoseFinding: Planning and Analyzing Dose Finding Experiments. R package version 0.9-15. https://CRAN.R-project.org/package=DoseFinding.
          </p>
          </li>
          <li>
          <p style='color: white'>
          Winston Chang, Joe Cheng, JJ Allaire, Yihui Xie and Jonathan McPherson (2018). shiny: Web Application Framework for R. R package version 1.1.0. https://CRAN.R-project.org/package=shiny
          </p>
          </li>
          "
        )
      )
    })
    #### ..... 3.2. Data Structure ####
    output$manual <- shiny::renderUI({
      list(
        HTML(
          "
          <img src='www/Iconx_dosedesignR.png' alt='dosedesignR Logo' width='350' height='350' align ='right'>
          <h2 style = 'color: white'>Data Structure and Format </h2>

          <h3 style = 'color: white'>Data Structure</h3>

          <p style='color:white'>
          In order to use all features of the <b>dosedesignR</b> you can upload a .RDS file which has to include 1-9 data.frames. <br>
          The dataframes have to include the two columns dose and response.

          <br>
          If you have one data.frame in your .RDS file the structure of the data frame should look like this example:
          </p>
          <code style='color: #5cb85c; background-color: #424242'>
          'data.frame':	25 obs. of  2 variables: <br>
          &nbsp;$ dose    : num  0 0 0 0 0 0.05 0.05 0.05 0.05 0.05 ...<br>
          &nbsp;$ response: num  0.15 0.32 0.5 0.01 0.2 1 2.1 0.5 1.8 1.2 ...

          </code>
          <p style = 'color: white'>
          If you want to include multiple data frames in one .RDS file your file structure should look like this expample: <br>
          <code style='color: #5cb85c; background-color: #424242'>

          List of 3 <br>
          &nbsp; $ :'data.frame':	25 obs. of  2 variables: <br>
          &nbsp; &nbsp;..$ dose    : num [1:25] 0 0 0 0 0 0.05 0.05 0.05 0.05 0.05 ... <br>
          &nbsp;&nbsp;..$ response: num [1:25] 0.15 0.32 0.5 0.01 0.2 1 2.1 0.5 1.8 1.2 ... <br>
          &nbsp; $ :'data.frame':	30 obs. of  2 variables: <br>
          &nbsp;&nbsp;..$ dose    : num [1:30] 0 0 0 0 0 0 0.05 0.05 0.05 0.05 ... <br>
          &nbsp;&nbsp;..$ response: num [1:30] 0.25 0.22 0.4 0.03 0.4 0.4 1.2 2.2 0.5 1.4 ... <br>
          &nbsp; &nbsp;$ :'data.frame':	25 obs. of  2 variables: <br>
          &nbsp;&nbsp;..$ dose    : num [1:25] 0 0 0 0 0 1 1 1 1 1 ... <br>
          &nbsp;&nbsp;..$ response: num [1:25] 0.15 0.32 0.5 0.01 0.2 1 2.1 0.5 1.8 1.2 ... <br>
          </code>

          "
        )
      )
    })
  }
)

#' Inner doseLevel module ui function
#'
#' @description A shiny Module for the doseLevel in dosedesignR.
#'
#' @param id Internal parameters for {shiny}.
#'
#' @noRd
#'
#' @importFrom shiny NS tagList

doseLevel_UI <- function(id) {
  ns <- shiny::NS(id)
  shiny::tagList(
    shiny::column(3,
      shiny::textInput(
        inputId = ns("level"),
        label = paste0("Level ", strsplit(id,"tmp")[[1]][[2]])
      ),
      shiny::textInput(
        inputId = ns("patients"),
        label = paste0("Group ", strsplit(id,"tmp")[[1]][[2]])
      )
    )
  )
}

#' Inner doseLevel module server function
#'
#' @param input,output,session Internal parameters for {shiny}.
#' @noRd

doseLevel_server <- function(input, output, session) {
  dosedesignR_green <- "#5cb85c"
  dosedesignR_blue <- "#3a6791"
  dosedesignR_red <- "#c94053"
  # observer to create 'green' or '", dosedesignR_red,"' borders around the textinputs for level and patient values
  shiny::observe({
    if (!is.null(input$level)) {
      if (input$level == "" & input$patients == "" ) {

      } else if (input$level != "" & input$patients =="" ) {
        shinyjs::runjs(paste0("document.getElementById('", session$ns("level"), "').style.border ='solid ", dosedesignR_green,"'"))
        shinyjs::runjs(paste0("document.getElementById('", session$ns("patients"), "').style.border ='solid ", dosedesignR_red,"'"))
      } else if (input$level =="" & input$patients !="" ) {
        shinyjs::runjs(paste0("document.getElementById('", session$ns("level"), "').style.border ='solid ", dosedesignR_red,"'"))
        shinyjs::runjs(paste0("document.getElementById('", session$ns("patients"), "').style.border ='solid ", dosedesignR_green,"'"))
      } else if (input$level !="" & input$patients !="" ) {
        shinyjs::runjs(paste0("document.getElementById('", session$ns("level"), "').style.border ='solid ", dosedesignR_green,"'"))
        shinyjs::runjs(paste0("document.getElementById('", session$ns("patients"), "').style.border ='solid ", dosedesignR_green,"'"))
      }
    }
  })

  return(
    list(
      level = input$level,
      patients = input$patients
    )
  )
}

dosedesignR_green <- "#5cb85c"
dosedesignR_blue <- "#3a6791"
dosedesignR_red <- "#c94053"
dosedesignR_white <- "#ebebeb"

performSimulation <- function(
  input,
  tab,
  inp,
  UserValue,
  sdsim,
  dmin,
  dmax,
  clevel,
  sim = input$sim,
  model= input$model
) {

  for(i in 1:length(inp)) {
    assign(paste0("inp", i), inp[[i]])
    assign(paste0("o_doses", i), inp[[i]]$optValdoses())
    assign(paste0("o_pats", i), inp[[i]]$optValpats())
    assign(paste0("u_doses", i), inp[[i]]$UserValdoses())
    assign(paste0("u_pats", i), inp[[i]]$UserValpats())
    assign(paste0("model"), inp[[tab]]$model())
  }

  sim <- input$sim

  if (!is.null(sim)) {

    nam1 <- rlang::sym(paste0(str_sub(tolower(sim), 1, 1), "_doses", str_sub(sim, str_length(sim), str_length(sim))))
    nam2 <- rlang::sym(paste0(str_sub(tolower(sim), 1, 1), "_pats", str_sub(sim, str_length(sim), str_length(sim))))

    simdesign <- data.frame(doses = eval(nam1), pats = eval(nam2))

    if (length(simdesign$doses) == 0) {

      pmodel <- ggplot2::ggplot(data = data.frame()) +
        ggplot2::geom_point() +
        ggplot2::xlim(-1,1) +
        gplot2::ylim(-1,1)  +
        ggplot2::theme_minimal() +
        ggplot2::theme(
          plot.background = ggplot2::element_rect(fill = "#383838")
        ) +
        ggplot2::geom_text() +
        ggplot2::annotate(
          "text",
          y = 0,
          x = 0,
          label = "No user defined model found.",
          angle = 0,
          colour = "white"
        ) +
        ggplot2::theme(
          legend.position = "none",
          axis.text = ggplot2::element_blank(),
          axis.title = ggplot2::element_blank(),
          panel.border = ggplot2::element_blank(),
          panel.grid.major = ggplot2::element_blank(),
          panel.grid.minor = ggplot2::element_blank(),
          text = ggplot2::element_text(
            family = "",
            face = "plain",
            colour = "white",
            size = 12,
            lineheight = 0.9,
            hjust = 0.5,
            vjust = 0.5,
            angle = 0,
            margin = ggplot2::margin(),
            debug = FALSE
          )
        )
    } else {
      if (model == "Linear") {
        Int <- inp[[tab]]$parameter1()
        Slp <- inp[[tab]]$parameter2()
        doses <- simdesign$doses
        pats <- floor(simdesign$pats)
        x <- rep(simdesign$doses, pats)
        y <- DoseFinding::linear(x, Int, Slp) + rnorm(sum(pats), 0, sdsim)
        datasim <- data.frame(x, y)
        model <- DoseFinding::fitMod(x, y, model = "linear")
        level <- clevel/100
        doseSeq <- seq(0, dmax, length = 201)
        truem <- DoseFinding::linear(doseSeq, Int, Slp)

        pred <- predict(model, predType = "ls-means", doseSeq = doseSeq, se.fit = TRUE)
        quant <- qt(1 - (1 - level)/2, df = model$df)
        lbnd <- pred$fit - quant * pred$se.fit
        ubnd <- pred$fit + quant * pred$se.fit
        predval <- pred$fit
        plotdata <- data.frame(doseSeq, predval, lbnd, ubnd, truem)
        ylimlow <- min(c(truem[length(truem)] - 3 * sdsim, truem[1] - 3 * sdsim))
        ylimhigh <- max(c(truem[1] + 3 * sdsim, truem[length(truem)] + 3 * sdsim))

        p <- ggplot2::ggplot(plotdata, aes(x = doseSeq, group = 1)) +
          ggplot2::theme_minimal() +
          ggplot2::theme(plot.background = element_rect(fill = "#383838")) +
          ggplot2::theme(
            legend.position = "none",
            axis.text = ggplot2::element_text(colour = "white"),
            panel.border = ggplot2::element_blank(),
            panel.grid.major = ggplot2::element_line(colour = "#474747"),
            panel.grid.minor = ggplot2::element_line(colour = "#474747", size = 0.25),
            text = ggplot2::element_text(
              family = "",
              face = "plain",
              colour = "white",
              size = 12,
              lineheight = 0.9,
              hjust = 0.5,
              vjust = 0.5,
              angle = 0,
              margin = margin(),
              debug = FALSE
            )
          ) +
          ggplot2::geom_ribbon(ggplot2::aes(ymin = lbnd, ymax = ubnd), fill = "#212121") +
          ggplot2::geom_line(ggplot2::aes(y = predval), colour= dosedesignR_green, lwd = 1.1) +
          ggplot2::geom_line(ggplot2::aes(x  = doseSeq, y = truem), colour = dosedesignR_red, lwd = 1.1) +
          ggplot2::xlim(dmin, dmax) +
          ggplot2::ylim(ylimlow, ylimhigh) +
          ggplot2::theme(
            axis.text = ggplot2::element_text(size = rel(1.1)),
            axis.title = ggplot2::element_text(size = rel(1.1))
          )

        tcec <- c("true curve", "estimated curve")
        datleg <-  data.frame(tcec, test = 1:2, y = 1:2)

        pmodel  <- p + ggplot2::geom_point(data = datasim, aes(x,y), colour = "grey70") +
          ggplot2::labs(x = "Dose", y = "Response") +
          ggplot2::geom_line(data = datleg, aes(colour = tcec, x = test, y = y, group = 1), alpha = 0) +
          ggplot2::scale_colour_manual(values = c(dosedesignR_red, dosedesignR_green), labels = c("true curve", "estimated curve")) +
          ggplot2::theme(
            legend.text = ggplot2::element_text(size = rel(1.1)),
            legend.key =  ggplot2::element_rect(fill = "#383838"),
            legend.margin = margin(l = -10),
            legend.position = "bottom",
            legend.title = ggplot2::element_blank()
          ) +
          ggplot2::guides(
            colour = ggplot2::guide_legend(override.aes = list(size = 1.05, alpha = 1))
          )
      } else if (model == "Emax") {
        E0 <- inp[[tab]]$parameter1()
        ED50 <- inp[[tab]]$parameter2()
        Emax <- inp[[tab]]$parameter3()
        doses <- simdesign$doses
        pats <- floor(simdesign$pats)
        x <- rep(simdesign$doses, pats)
        y <- DoseFinding::emax(x, E0, Emax, ED50) + rnorm(sum(pats), 0, sdsim)
        datasim <- data.frame(x,y)
        model <- DoseFinding::fitMod(x,y, model="emax", bnds = defBnds(max(doses))$emax)
        level <- clevel/100
        model <- fitMod(x, y, model = "emax", bnds = defBnds(max(simdesign$doses))$emax)
        doseSeq <- seq(0, dmax, length = 201)
        truem <- emax(doseSeq, E0, Emax, ED50)
        pred <- predict(model, predType = "ls-means", doseSeq = doseSeq, se.fit = TRUE)
        quant <- qt(1 - (1 - level)/2, df = model$df)
        lbnd <- pred$fit - quant * pred$se.fit
        ubnd <- pred$fit + quant * pred$se.fit
        predval <- pred$fit
        plotdata <- data.frame(doseSeq, predval, lbnd,ubnd, truem)

        ylimlow <- min(c(truem[length(truem)] - 3 * sdsim, truem[1] - 3 * sdsim))
        ylimhigh <- max(c(truem[1] + 3 * sdsim, truem[length(truem)] + 3 * sdsim))

        p <- ggplot2::ggplot(plotdata, aes(x = doseSeq, group = 1)) +
          ggplot2::theme_minimal() +
          ggplot2::theme(
            plot.background = ggplot2::element_rect(fill = "#383838")
          ) +
          ggplot2::theme(
            legend.position = "none",
            axis.text = ggplot2::element_text(colour = "white"),
            panel.border = ggplot2::element_blank(),
            panel.grid.major = ggplot2::element_line(colour = "#474747"),
            panel.grid.minor = ggplot2::element_line(colour = "#474747", size = 0.25),
            text = ggplot2::element_text(
              family = "",
              face = "plain",
              colour = "white",
              size = 12,
              lineheight = 0.9,
              hjust = 0.5,
              vjust = 0.5,
              angle = 0,
              margin = margin(),
              debug = FALSE
            )
          ) +
          ggplot2::geom_ribbon(aes(ymin = lbnd, ymax = ubnd), fill = "#212121") +
          ggplot2::geom_line(aes(y = predval), colour = dosedesignR_green, lwd = 1.1) +
          ggplot2::geom_line(aes(x = doseSeq, y = truem), colour = dosedesignR_red, lwd = 1.1) + xlim(dmin, dmax) +
          ggplot2::ylim(ylimlow, ylimhigh) +
          ggplot2::theme(
            axis.text = element_text(size = rel(1.1)),
            axis.title = element_text(size = rel(1.1))
          )
        tcec<- c("true curve", "estimated curve")
        datleg <-  data.frame(tcec, test = 1:2, y = 1:2)

        pmodel  <- p +
          ggplot2::geom_point(data = datasim, aes(x, y), colour = "grey70") +
          ggplot2::labs(x = "Dose", y = "Response") +
          ggplot2::geom_line(data = datleg, aes(colour = tcec, x = test, y = y,group = 1), alpha = 0) +
          ggplot2::scale_colour_manual(values = c(dosedesignR_red, dosedesignR_green), labels = c("true curve", "estimated curve")) +
          ggplot2::theme(
            legend.text = ggplot2::element_text(size = rel(1.1)), legend.key =  element_rect(fill = "#383838"),
            legend.margin = margin(l = -10), legend.position = "bottom", legend.title = element_blank()
          ) +
          ggplot2::guides(colour = guide_legend(override.aes = list(size = 1.05, alpha = 1)))

    } else if (model == "Sigmoidal Emax") {
      E0 <- inp[[tab]]$parameter1()
      ED50 <- inp[[tab]]$parameter2()
      Emax <- inp[[tab]]$parameter3()
      Hill <- inp[[tab]]$parameter4()
      doses <- simdesign$doses
      pats <- floor(simdesign$pats)
      x <- rep(simdesign$doses, pats)
      y <- DoseFinding::sigEmax(x, E0, Emax, ED50, Hill) + rnorm(sum(pats), 0, sdsim)
      datasim <- data.frame(x, y)
      model <- DoseFinding::fitMod(x, y, model = "sigEmax", bnds = defBnds(max(simdesign$doses))$sigEmax)
      level <- clevel/100
      doseSeq <- seq(0,  dmax, length = 201)
      truem <- DoseFinding::sigEmax(doseSeq, E0, Emax, ED50, Hill)
      pred <- predict(model, predType = "ls-means", doseSeq = doseSeq, se.fit = TRUE)
      quant <- qt(1 - (1 - level)/2, df = model$df)
      lbnd <- pred$fit - quant * pred$se.fit
      ubnd <- pred$fit + quant * pred$se.fit
      predval <- pred$fit
      plotdata <- data.frame(doseSeq, predval, lbnd, ubnd, truem)
      ylimlow <- min(c(truem[length(truem)] - 3 * sdsim, truem[1] - 3 * sdsim))
      ylimhigh <- max(c(truem[1] + 3 * sdsim, truem[length(truem)] + 3 * sdsim))

      p <- ggplot2::ggplot(plotdata, aes(x = doseSeq, group = 1)) +
        ggplot2::theme_minimal() +
        ggplot2::theme(plot.background = element_rect(fill = "#383838")) +
        ggplot2::theme(
          legend.position = "none",
          axis.text = ggplot2::element_text(colour = "white"),
          panel.border = ggplot2::element_blank(),
          panel.grid.major = ggplot2::element_line(colour = "#474747"),
          panel.grid.minor = ggplot2::element_line(colour = "#474747", size = 0.25),
          text = ggplot2::element_text(
            family = "",
            face = "plain",
            colour = "white",
            size = 12,
            lineheight = 0.9,
            hjust = 0.5,
            vjust = 0.5,
            angle = 0,
            margin = margin(),
            debug = FALSE
          )
        ) +
        ggplot2::geom_ribbon(ggplot2::aes(ymin = lbnd, ymax = ubnd), fill = "#212121") +
        ggplot2::geom_line(ggplot2::aes(y = predval), colour = dosedesignR_green, lwd = 1.1) +
        ggplot2::geom_line(ggplot2::aes(x = doseSeq, y = truem), colour = dosedesignR_red, lwd = 1.1) + xlim(dmin, dmax) +
        ggplot2::ylim(ylimlow, ylimhigh) +
        ggplot2::theme(
          axis.text = element_text(size = rel(1.1)),
          axis.title = element_text(size = rel(1.1))
        )

      tcec <- c("true curve", "estimated curve")
      datleg <-  data.frame(tcec, test = 1:2, y = 1:2)

      pmodel  <- p +
        ggplot2::geom_point(data = datasim, aes(x,y), colour = "grey70") +
        ggplot2::labs(x = "Dose", y = "Response") +
        ggplot2::geom_line(data = datleg, aes(colour = tcec, x = test, y = y, group = 1), alpha = 0) +
        ggplot2::scale_colour_manual(values = c(dosedesignR_red, dosedesignR_green), labels = c("true curve", "estimated curve")) +
        ggplot2::theme(
          legend.text = ggplot2::element_text(size = rel(1.1)),
          legend.key =  ggplot2::element_rect(fill = "#383838"),
          legend.margin = margin(l = -10),
          legend.position = "bottom",
          legend.title = ggplot2::element_blank()
        ) +
        ggplot2::guides(colour = guide_legend(override.aes = list(size = 1.05, alpha = 1)))

      }
    }
    return(pmodel)
  }
}


#for rmarkdown report:
performSimulation2 <- function(
  tab,
  inp,
  sdsim,
  dmin,
  dmax,
  clevel,
  sim = input$sim,
  model = input$model
) {

  for(i in 1:length(inp)){
    assign(paste0("inp", i), inp[[i]])
    assign(paste0("o_doses", i), inp[[i]]$optValdoses())
    assign(paste0("o_pats", i), inp[[i]]$optValpats())
    assign(paste0("u_doses", i), inp[[i]]$UserValdoses())
    assign(paste0("u_pats", i), inp[[i]]$UserValpats())
    assign(paste0("model"), inp[[tab]]$model())
  }


  if (!is.null(sim)) {
    nam1 <- rlang::sym(paste0(str_sub(tolower(sim), 1, 1), "_doses", str_sub(sim, str_length(sim), str_length(sim))))
    nam2 <- rlang::sym(paste0(str_sub(tolower(sim), 1, 1), "_pats", str_sub(sim, str_length(sim), str_length(sim))))

    simdesign <- data.frame(doses = eval(nam1), pats = eval(nam2))

    if (length(simdesign$doses) == 0) {
      stop("No user defined model found.")
    }

    if (model == "Linear") {
      Int <- inp[[tab]]$parameter1()
      Slp <- inp[[tab]]$parameter2()
      doses <- simdesign$doses
      pats <- floor(simdesign$pats)
      x <- rep(simdesign$doses, pats)
      y <- DoseFinding::linear(x, Int, Slp) + rnorm(sum(pats), 0, sdsim)
      datasim <- data.frame(x, y)
      model <- DoseFinding::fitMod(x, y, model = "linear")
      level <- clevel/100
      doseSeq <- seq(0, dmax, length = 201)
      truem <- DoseFinding::linear(doseSeq, Int, Slp)

      pred <- predict(model, predType = "ls-means", doseSeq = doseSeq, se.fit = TRUE)
      quant <- qt(1 - (1 - level)/2, df = model$df)
      lbnd <- pred$fit - quant * pred$se.fit
      ubnd <- pred$fit + quant * pred$se.fit
      predval <- pred$fit
      plotdata <- data.frame(doseSeq, predval, lbnd, ubnd, truem)
      ylimlow <- min(c(truem[length(truem)] - 3 * sdsim, truem[1] - 3 * sdsim))
      ylimhigh <- max(c(truem[1] + 3 * sdsim, truem[length(truem)] + 3 * sdsim))

      p <- ggplot2::ggplot(plotdata, aes(x = doseSeq, group = 1)) +
        ggplot2::theme_minimal() +
        ggplot2::theme(plot.background = element_rect(fill = "#f0f0f0")) +
        ggplot2::theme(
          legend.position = "none",
          axis.text = ggplot2::element_text(colour = "black"),
          panel.border = ggplot2::element_blank(),
          panel.grid.major = ggplot2::element_line(colour = "#fafafa"),
          panel.grid.minor = ggplot2::element_line(colour = "#fafafa", size = 0.25),
          text = ggplot2::element_text(
            family = "",
            face = "plain",
            colour = "black",
            size = 12,
            lineheight = 0.9,
            hjust = 0.5,
            vjust = 0.5,
            angle = 0,
            margin = margin(),
            debug = FALSE
          )
        ) +
        ggplot2::geom_ribbon(aes(ymin = lbnd, ymax = ubnd), fill = "grey70") +
        ggplot2::geom_line(aes(y = predval), colour= dosedesignR_green, lwd = 1.1) +
        ggplot2::geom_line(aes(x  = doseSeq, y = truem), colour = dosedesignR_red, lwd = 1.1) + xlim(dmin, dmax) +
        ggplot2::ylim(ylimlow, ylimhigh) +
        ggplot2::theme(
          axis.text = ggplot2::element_text(size = rel(1.1)),
          axis.title = element_text(size = rel(1.1))
        )

      tcec <- c("true curve", "estimated curve")
      datleg <-  data.frame(tcec, test = 1:2, y = 1:2)

      pmodel  <- p +
        ggplot2::geom_point(data = datasim, aes(x,y), colour = "#212121") +
        ggplot2::labs(x = "Dose", y = "Response") +
        ggplot2::geom_line(data = datleg, aes(colour = tcec, x = test, y = y, group = 1), alpha = 0) +
        ggplot2::scale_colour_manual(values = c(dosedesignR_red, dosedesignR_green), labels = c("true curve", "estimated curve")) +
        ggplot2::theme(
          legend.text = ggplot2::element_text(size = rel(1.1)),
          legend.key =  ggplot2::element_rect(fill = "#f0f0f0"),
          legend.margin = margin(l = -10),
          legend.position = "bottom",
          legend.title = ggplot2::element_blank()
        ) +
        ggplot2::guides(colour = guide_legend(override.aes = list(size = 1.05, alpha = 1)))
    } else if (model == "Emax") {
      E0 <- inp[[tab]]$parameter1()
      ED50 <- inp[[tab]]$parameter2()
      Emax <- inp[[tab]]$parameter3()
      doses <- simdesign$doses
      pats <- floor(simdesign$pats)
      x <- rep(simdesign$doses, pats)
      y <- DoseFinding::emax(x, E0, Emax, ED50) + rnorm(sum(pats), 0, sdsim)
      datasim <- data.frame(x,y)
      model <- DoseFinding::fitMod(x,y, model="emax", bnds = defBnds(max(doses))$emax)
      level <- clevel/100
      model <- fitMod(x, y, model = "emax", bnds = defBnds(max(simdesign$doses))$emax)
      doseSeq <- seq(0, dmax, length = 201)
      truem <- emax(doseSeq, E0, Emax, ED50)
      pred <- predict(model, predType = "ls-means", doseSeq = doseSeq, se.fit = TRUE)
      quant <- qt(1 - (1 - level)/2, df = model$df)
      lbnd <- pred$fit - quant * pred$se.fit
      ubnd <- pred$fit + quant * pred$se.fit
      predval <- pred$fit
      plotdata <- data.frame(doseSeq, predval, lbnd,ubnd, truem)

      ylimlow <- min(c(truem[length(truem)] - 3 * sdsim, truem[1] - 3 * sdsim))
      ylimhigh <- max(c(truem[1] + 3 * sdsim, truem[length(truem)] + 3 * sdsim))

      p <- ggplot2::ggplot(plotdata, aes(x = doseSeq, group = 1)) +
        ggplot2::theme_minimal() +
        ggplot2::theme(plot.background = element_rect(fill = "#f0f0f0")) +
        ggplot2::theme(
          legend.position = "none",
          axis.text = ggplot2::element_text(colour = "black"),
          panel.border = ggplot2::element_blank(),
          panel.grid.major = ggplot2::element_line(colour = "#fafafa"),
          panel.grid.minor = ggplot2::element_line(colour = "#fafafa", size = 0.25),
          text = ggplot2::element_text(
            family = "",
            face = "plain",
            colour = "black",
            size = 12,
            lineheight = 0.9,
            hjust = 0.5,
            vjust = 0.5,
            angle = 0,
            margin = margin(),
            debug = FALSE
          )
        ) +
        ggplot2::geom_ribbon(aes(ymin = lbnd, ymax = ubnd), fill = "grey70") +
        ggplot2::geom_line(aes(y = predval), colour = dosedesignR_green, lwd = 1.1) +
        ggplot2::geom_line(aes(x = doseSeq, y = truem), colour = dosedesignR_red, lwd = 1.1) + xlim(dmin, dmax) +
        ggplot2::ylim(ylimlow, ylimhigh) +
        ggplot2::theme(
          axis.text = element_text(size = rel(1.1)),
          axis.title = element_text(size = rel(1.1))
        )

      tcec <- c("true curve", "estimated curve")
      datleg <-  data.frame(tcec, test = 1:2, y = 1:2)

      pmodel  <- p +
        ggplot2::geom_point(data = datasim, aes(x, y), colour = "#212121") +
        ggplot2::labs(x = "Dose", y = "Response") +
        ggplot2::geom_line(data = datleg, aes(colour = tcec, x = test, y = y,group = 1), alpha = 0) +
        ggplot2::scale_colour_manual(values = c(dosedesignR_red, dosedesignR_green), labels = c("true curve", "estimated curve")) +
        ggplot2::theme(
          legend.text = ggplot2::element_text(size = rel(1.1)),
          legend.key =  ggplot2::element_rect(fill = "#f0f0f0"),
          legend.margin = margin(l = -10),
          legend.position = "bottom",
          legend.title = ggplot2::element_blank()) +
        ggplot2::guides(colour = guide_legend(override.aes = list(size = 1.05, alpha = 1)))

    } else if (model == "Sigmoidal Emax") {
      E0 <- inp[[tab]]$parameter1()
      ED50 <- inp[[tab]]$parameter2()
      Emax <- inp[[tab]]$parameter3()
      Hill <- inp[[tab]]$parameter4()
      doses <- simdesign$doses
      pats <- floor(simdesign$pats)
      x <- rep(simdesign$doses, pats)
      y <- DoseFinding::sigEmax(x, E0, Emax, ED50, Hill) + rnorm(sum(pats), 0, sdsim)
      datasim <- data.frame(x, y)
      model <- DoseFinding::fitMod(x, y, model = "sigEmax", bnds = defBnds(max(simdesign$doses))$sigEmax)
      level <- clevel/100
      doseSeq <- seq(0,  dmax, length = 201)
      truem <- DoseFinding::sigEmax(doseSeq, E0, Emax, ED50, Hill)
      pred <- predict(model, predType = "ls-means", doseSeq = doseSeq, se.fit = TRUE)
      quant <- qt(1 - (1 - level)/2, df = model$df)
      lbnd <- pred$fit - quant * pred$se.fit
      ubnd <- pred$fit + quant * pred$se.fit
      predval <- pred$fit
      plotdata <- data.frame(doseSeq, predval, lbnd, ubnd, truem)
      ylimlow <- min(c(truem[length(truem)] - 3 * sdsim, truem[1] - 3 * sdsim))
      ylimhigh <- max(c(truem[1] + 3 * sdsim, truem[length(truem)] + 3 * sdsim))
      p <- ggplot2::ggplot(plotdata, aes(x = doseSeq, group = 1)) +
        ggplot2::theme_minimal() +
        ggplot2::theme(plot.background = element_rect(fill = "#f0f0f0")) +
        ggplot2::theme(
          legend.position = "none",
          axis.text = ggplot2::element_text(colour = "black"),
          panel.border = ggplot2::element_blank(),
          panel.grid.major = ggplot2::element_line(colour = "#fafafa"),
          panel.grid.minor = ggplot2::element_line(colour = "#fafafa", size = 0.25),
          text = ggplot2::element_text(
            family = "",
            face = "plain",
            colour = "black",
            size = 12,
            lineheight = 0.9,
            hjust = 0.5,
            vjust = 0.5,
            angle = 0,
            margin = margin(),
            debug = FALSE
          )
        ) +
        ggplot2::geom_ribbon(ggplot2::aes(ymin = lbnd, ymax = ubnd), fill = "grey70") +
        ggplot2::geom_line(ggplot2::aes(y = predval), colour = dosedesignR_green, lwd = 1.1) +
        ggplot2::geom_line(ggplot2::aes(x = doseSeq, y = truem), colour = dosedesignR_red, lwd = 1.1) + xlim(dmin, dmax) +
        ggplot2::ylim(ylimlow, ylimhigh) +
        ggplot2::theme(
          axis.text = ggplot2::element_text(size = rel(1.1)),
          axis.title = ggplot2::element_text(size = rel(1.1))
        )

      tcec <- c("true curve", "estimated curve")
      datleg <-  data.frame(tcec, test = 1:2, y = 1:2)

      pmodel  <- p +
        ggplot2::geom_point(data = datasim, aes(x,y), colour = "#212121") +
        ggplot2::labs(x = "Dose", y = "Response") +
        ggplot2::geom_line(data = datleg, aes(colour = tcec, x = test, y = y, group = 1), alpha = 0) +
        ggplot2::scale_colour_manual(values = c(dosedesignR_red, dosedesignR_green), labels = c("true curve", "estimated curve")) +
        ggplot2::theme(
          legend.text = ggplot2::element_text(size = rel(1.1)),
          legend.key =  ggplot2::element_rect(fill = "#f0f0f0"),
          legend.margin = margin(l = -10), legend.position = "bottom", legend.title = ggplot2::element_blank()
        ) +
        ggplot2::guides(colour = guide_legend(override.aes = list(size = 1.05, alpha = 1)))

    }
    return(pmodel)
  }
}

The dataset *`r params$data_name`* was loaded with **`r paste0("<span style = 'color:", params$data_cols[params$selectnr],"'> Dataset",params$selectnr,"</span>")`**. 
The respective colored line represents the maximum likelihood estimated based on the data sets.

#### Model Candidate {{i}} (`r params$model{{i}}`):<br>
  ```{r echo = FALSE}
    
  
  if(length(params$data2) > 0 & !is.na(params$model{{i}})){ 
    
    
  x <- ComputeOptimal2(
    model  = params$model{{i}},
    regimen = params$regimen,
    levels = params$levels,
    dmin = params$minimumDose,
    dmax = params$maximumDose,
    parameter1 = params$param{{i}}_1,
    parameter2 = params$param{{i}}_2,
    parameter3 = params$param{{i}}_3,
    parameter4 = params$param{{i}}_4
  )
  
  data2 <- params$data2[params$selectnr]

      if (params$model{{i}} == "Linear") {
        tmp <- lapply(data2, function(x){
          as.data.frame(t(DoseFinding::fitMod(x$df$dose, x$df$response, model = "linear")$coefs))
        })
        tmp2 <- lapply(tmp, function(x){
          data.frame("Intercept" = c(params$param{{i}}_1, round(as.numeric(x[1]), 2)), "Slope" = c(params$param{{i}}_2, round(as.numeric(x[2]), 2)))})
      }
      if (params$model{{i}} == "Emax") {
        tmp <- lapply(data2, function(x){
          as.data.frame(t(DoseFinding::fitMod(x$df$dose, x$df$response, model = "emax", bnds = defBnds(max(x$df$dose))$emax)$coefs))
         })
        tmp2 <- lapply(tmp,function(x){
          data.frame("E0" = c(params$param{{i}}_1, round(as.numeric(x[1]), 2)),
                     "ED50" = c(params$param{{i}}_2, round(as.numeric(x[3]), 2)),
                     "Emax" = c(params$param{{i}}_3, round(as.numeric(x[2]), 2)))
          })
      }
      if (params$model{{i}} == "Sigmoidal Emax") {
        tmp <- lapply(data2, function(x){
          as.data.frame(t(DoseFinding::fitMod(x$df$dose, x$df$response, model = "sigEmax", bnds = defBnds(max(x$df$dose))$sigEmax)$coefs))
          })
        tmp2 <- lapply(tmp, function(x){
          data.frame("E0" = c(params$param{{i}}_1, round(as.numeric(x[1]), 2)),
                     "ED50" = c(params$param{{i}}_2, round(as.numeric(x[3]), 2)),
                     "Emax" = c(params$param{{i}}_3,round(as.numeric(x[2]), 2)),
                     "Hill" = c(params$param{{i}}_4, round(as.numeric(x[4]), 2)))
        })
      }

      data2 
      
      
      tmp2 <- rbind.data.frame(tmp2[[1]][1, ], do.call(rbind.data.frame, lapply(tmp2, function(x) 
      data.frame(do.call(cbind.data.frame, x[2, ]), check.names = FALSE))))

      tmp2 
      knitr::kable(tmp2) %>% 
        kableExtra::kable_styling(bootstrap_options = "striped", full_width = F, position = "left")%>%
        column_spec(1:dim(tmp2)[2], bold = T, color = "white", background = c("#c94053",rgb(f_col_report(seq(0, 1, length = dim(tmp2)[1]-1)), maxColorValue = 255))) 
  } 
  if (length(params$data2) == 0) {
  
    if (params$model{{i}} == "Linear") {
        tmp2 <- data.frame("Intercept" = params$param{{i}}_1, "Slope" = params$param{{i}}_2)
    }
    if (params$model{{i}} == "Emax") {
        tmp2 <- data.frame("E0" = params$param{{i}}_1,
                     "ED50" = params$param{{i}}_2,
                     "Emax" = params$param{{i}}_3)
    }             
    if (params$model{{i}} == "Sigmoidal Emax") {
      tmp2 <- data.frame("E0" = params$param{{i}}_1,
                     "ED50" = params$param{{i}}_2,
                     "Emax" = params$param{{i}}_3,
                     "Hill" = params$param{{i}}_4)
    }
      
    tmp2 
    knitr::kable(tmp2) %>% 
        kableExtra::kable_styling(bootstrap_options = "striped", full_width = F, position = "left") %>%
        column_spec(1:dim(tmp2)[2], bold = T, color = "white", background = c("#c94053",rgb(f_col_report(seq(0, 1, length = dim(tmp2)[1]-1)), maxColorValue = 255))) 
  }
  ```
  
  
  ```{r echo = FALSE, warning=FALSE}
#Candidate Model {{i}}:
ComputeModelFunction2(
  model = params$model{{i}},
  tab = {{i}},
  ymin = params$minimumResponse,
  ymax = params$maximumResponse,
  dmin = params$minimumDose,
  dmax = params$maximumDose,
  data = params$data,
  parameter1 = params$param{{i}}_1,
  parameter2 = params$param{{i}}_2,
  parameter3 = params$param{{i}}_3,
  parameter4 = params$param{{i}}_4,
  data_esti = params$data2,
  plot_opt = params$plot_opt,
  selectnr = params$selectnr
)
```

### Candidate Model {{i}} (`r params$model{{i}}`)

```{r, perf_Sim{{i}}, echo = FALSE, warning=FALSE} 
performSimulation2(tab = {{i}},inp = params$call_Mod, sdsim = params$sdsim,
dmin = params$minimumDose,dmax = params$maximumDose,clevel = params$clevel,sim = "Optimal {{i}}", model = params$model{{i}})
```

### Simulation (optional)

#### General options
For the simulation a normal distributed error with a standard deviation of `r params$sdsim` is assumed. The confidence intervals are at a pointwise `r params$clevel`% level.
For the candidate model 1 it is assumed that the model 1 is true. The design is as planned in Optimal Design2, i.e. a patients on dose a,…. 
The simulation leads to following result(s):

---
title: "dosedesignR Report"
output_format: html
always_allow_html: true
params:
  numberCandidateModels: NA
  maximumResponse: NA
  minimumResponse: NA
  maximumDose: NA
  minimumDose: NA
  model1: NA
  param1_1: NA
  param1_2: NA
  param1_3: NA
  param1_4: NA
  model2: NA
  param2_1: NA
  param2_2: NA
  param2_3: NA
  param2_4: NA
  model3: NA
  param3_1: NA
  param3_2: NA
  param3_3: NA
  param3_4: NA
  model4: NA
  param4_1: NA
  param4_2: NA
  param4_3: NA
  param4_4: NA
  model5: NA
  param5_1: NA
  param5_2: NA
  param5_3: NA
  param5_4: NA
  model6: NA
  param6_1: NA
  param6_2: NA
  param6_3: NA
  param6_4: NA
  model7: NA
  param7_1: NA
  param7_2: NA
  param7_3: NA
  param7_4: NA
  model8: NA
  param8_1: NA
  param8_2: NA
  param8_3: NA
  param8_4: NA
  model9: NA
  param9_1: NA
  param9_2: NA
  param9_3: NA
  param9_4: NA
  model10: NA
  param10_1: NA
  param10_2: NA
  param10_3: NA
  param10_4: NA
  model11: NA
  param11_1: NA
  param11_2: NA
  param11_3: NA
  param11_4: NA
  model12: NA
  param12_1: NA
  param12_2: NA
  param12_3: NA
  param12_4: NA
  data: NA
  data2: NA
  plot_opt: NA
  selectnr: NA
  sdsim: NA
  clevel: NA
  data_name: NA
  npats: NA
  regimen: NA
  regimen_text: NA
  levels: NA
  user_chosen1: NA
  user_chosen2: NA
  user_chosen3: NA
  user_chosen4: NA
  user_chosen5: NA
  user_chosen6: NA
  user_chosen7: NA
  user_chosen8: NA
  user_chosen9: NA
  user_chosen10: NA
  user_chosen11: NA
  user_chosen12: NA
  call_Mod: NA
  report_selection: NA
  report_tabs: NA
  data_cols: NA
  rendered_by_shiny: FALSE
  
---
<div align="left">
![](Iconx_dosedesignR.png){width=150px; height=150px}
</div>
Created: `r Sys.time()`

```{r child =if ("General Options" %in% params$report_selection) 'General_options.Rmd'}
```
  
```{r child = 'Overview_models_Intro.Rmd'}

```
```{r echo = FALSE}
if (params$rendered_by_shiny)
  shiny::setProgress(0.1) 
```
```{r child =if (length(params$data2) > 0) 'Overview_models_Intro2.Rmd'}
```
```{r echo = FALSE}
if (params$rendered_by_shiny)
  shiny::setProgress(0.2) 
```
```{r include = FALSE}
prms <- params$report_tabs

out <-  NULL
for (i in prms) out <- c(out, knitr::knit_expand("Overview_models.Rmd"))
```

`r paste(knitr::knit(text = out), collapse = '\n')`  


```{r child = if ("Optimal Design" %in% params$report_selection) 'Optimal_design_Intro.Rmd'}

```
```{r echo = FALSE}
if (params$rendered_by_shiny)
  shiny::setProgress(0.3) 
```
```{r include = FALSE}
prms <- params$report_tabs

out <-  NULL
for (i in prms) out <- c(out, knitr::knit_expand("Optimal_design.Rmd"))
```

`r if ("Optimal Design" %in% params$report_selection) paste(knitr::knit(text = out), collapse = '\n')`  

```{r child = if ("Simulation" %in% params$report_selection) 'Simulation_Intro.Rmd'}

```
```{r echo = FALSE}
if (params$rendered_by_shiny)
  shiny::setProgress(0.4) 
```
```{r include = FALSE}
prms <- params$report_tabs

out <-  NULL
for (i in prms) out <- c(out, knitr::knit_expand("Simulation.Rmd"))
```

`r if ("Simulation" %in% params$report_selection) paste(knitr::knit(text = out), collapse = '\n')`
```{r echo = FALSE}
if (params$rendered_by_shiny)
  shiny::setProgress(0.7) 
```

```{r echo = FALSE}
if (params$rendered_by_shiny)
  shiny::setProgress(0.9) 
```
```{r child = if ("Session Info" %in% params$report_selection) 'Session_info.Rmd'}

```

```{r echo = FALSE}
if (params$rendered_by_shiny)
  shiny::setProgress(1) 
```

Candidate Model {{i}} (`r params$model{{i}}`)
```{r, CompOpt{{i}}, echo = FALSE}

x <- ComputeOptimal2(
  model= params$model{{i}},
  regimen = params$regimen,
  dmin = params$minimumDose,
  dmax = params$maximumDose,
  levels = params$levels,
  parameter1 = params$param{{i}}_1,
  parameter2 = params$param{{i}}_2,
  parameter3 = params$param{{i}}_3,
  parameter4 = params$param{{i}}_4              
)
x_table <- t(x$res)
x_table[, 2] <- round(x_table[, 2] * params$npats, 1)
colnames(x_table) <- c("Dose", "Number of Patients")
knitr::kable(x_table) %>% 
  kableExtra::kable_styling(bootstrap_options = "striped", full_width = F, position = "left")
```


```{r, CompEffi{{i}}, echo = FALSE} 

  if(is.na(params$user_chosen{{i}})) {
    user_Val <- NULL
  } else {
    user_Val <- params$user_chosen{{i}}
  }

cE <- ComputeEfficiency2(userVal = user_Val, optVal = x, model = params$model{{i}}, npats = params$npats)

  if (dim(cE)[1] == 3 & dim(cE)[2] == 1) {
    colnames(cE) <- NULL
    rownames(cE) <- c("Patients", "Efficiency [%]", "Additional patients needed")
    } else if (dim(cE)[1] == 1 & dim(cE)[2] == 1) {
      colnames(cE) <- NULL
      rownames(cE) <- c("Information:")
  }
```
  
`r ifelse(all(is.na(params$user_chosen{{i}})),"",paste0("The design with ", paste(c(apply(params$user_chosen{{i}},1,function(x){paste0(x[2]," patients at level ", x[1],",")})), collapse = " "), "(overall ",sum(params$user_chosen{{i}}$patients), " patients) has an efficiency of", cE[2,1], "% compared to the optimal design as described before.", cE[1,1], " additional patients distributed proportional to the dose levels in the user chosen design are needed to reach 100% efficiency"))`

### Overview of models

This section provides an overview of all models in the candidate set. 
The **<span style = "color: #c94053"> red line </span>** represents the dose-response curve for the chosen parameter.

### Optimal Designs (optional)

Optimal Designs are based on the chosen parameter setting in the candidate models above.
The following options for the optimal design were chosen

Number of patients: `r params$npats`

Dose restriction: `r params$regimen_text`

Optimality Criterion: D-optimality

### General options

Minimum response:`r params$minimumResponse`.<br>
Maximum response:`r params$maximumResponse`.<br>
Minimum Dose:`r params$minimumDose`.<br>
Maximum Dose:`r params$maximumDose`.<br>
